<?php
require_once("../../classes/class.users.php");
require_once("../../classes/class.validation.php");
require_once("../../classes/class.authentication.php");

require_once('../../classes/school_administration/class.classes.php');
require_once('../../classes/school_administration/class.class_sections.php');
require_once('../../classes/school_administration/class.section_master.php');
require_once("../../classes/school_administration/class.students.php");
require_once("../../classes/school_administration/class.student_details.php");

require_once('../../classes/examination/class.exam_types.php');
require_once('../../classes/examination/class.exams.php');

require_once("../../classes/examination/class.student_exam_mark.php");

require_once('../../classes/class.ui_helpers.php');

require_once('../../includes/helpers.inc.php');
require_once('../../includes/global_defaults.inc.php');

//1. RECHECK IF THE USER IS VALID //
try
{
	$AuthObject = new ApplicationAuthentication;
	$LoggedUser = new User(0, $AuthObject->CheckValidUser());
}

// THIS CATCH BLOCK BUBBLES THE EXCEPTION TO THE BUILT IN 'Exception' CLASS IF THERE ARE ANY UNCAUGHT ERRORS //
catch (ApplicationAuthException $e)
{
	header('location:../unauthorized_login_admin.php');
	exit;
}
catch (Exception $e)
{
	header('location:../unauthorized_login_admin.php');
	exit;
}
// END OF 1. //

if ($LoggedUser->HasPermissionForTask(TASK_LIST_EXAM) !== true)
{
	header('location:/admin/unauthorized_login_admin.php');
	exit;
}

$HasErrors = false;
$TotalRecords = 0;

$RecordDeletedSuccessfully = false;

$ClassList =  array();
$ClassList = AddedClass::GetActiveClasses();

$ClassSectionsList =  array();
$ClassSubjectsList = array();

$ExamTypeList = array();
$ExamTypeList = ExamType::GetActiveExamTypes();

$Clean = array();

$Clean['Process'] = 0;

$Clean['ClassID'] = 0;
$Clean['ClassSectionID'] = 0;
$Clean['ExamTypeID'] = 0;
$Clean['ClassSubjectID'] = 0;

// paging and sorting variables start here  //
$Clean['AllRecords'] = '';
$Clean['CurrentPage'] = 1;
$TotalPages = 0;

$Start = 0;
$Limit = 30;
// end of paging variables //

$AllFailStudents = array();
$TotalStudents = array();

if (isset($_GET['hdnProcess']))
{
    $Clean['Process'] = (int) $_GET['hdnProcess'];
}
else if (isset($_GET['Process']))
{
    $Clean['Process'] = (int) $_GET['Process'];
}
switch ($Clean['Process'])
{
    case 7:        
        if (isset($_GET['drdClass']))
        {
            $Clean['ClassID'] = (int) $_GET['drdClass'];
        }
        elseif (isset($_GET['ClassID']))
        {
            $Clean['ClassID'] = (int) $_GET['ClassID'];
        }

        if (isset($_GET['drdClassSection']))
        {
            $Clean['ClassSectionID'] = (int) $_GET['drdClassSection'];
        }

        elseif (isset($_GET['ClassSectionID']))
        {
            $Clean['ClassSectionID'] = (int) $_GET['ClassSectionID'];
        }

        if (isset($_GET['drdExamType']))
        {
            $Clean['ExamTypeID'] = (int) $_GET['drdExamType'];
        }
        elseif (isset($_GET['ExamTypeID']))
        {
            $Clean['ExamTypeID'] = (int) $_GET['ExamTypeID'];
        }

        if (isset($_GET['drdClassSubject']))
        {
            $Clean['ClassSubjectID'] = (int) $_GET['drdClassSubject'];
        }
        elseif (isset($_GET['ClassSubjectID']))
        {
            $Clean['ClassSubjectID'] = (int) $_GET['ClassSubjectID'];
        }

        $NewRecordValidator = new Validator();
        
      if ($NewRecordValidator->ValidateInSelect($Clean['ClassID'], $ClassList, 'Please select a valid class.')) 
		{
			$ClassSectionsList = ClassSections::GetClassSections($Clean['ClassID']);

            $NewRecordValidator->ValidateInSelect($Clean['ClassSectionID'], $ClassSectionsList, 'Please select a valid section.');

            $SelectedAddedClass = new AddedClass($Clean['ClassID']);
            $SelectedAddedClass->FillAssignedSubjects();

            $ClassSubjectsList = $SelectedAddedClass->GetAssignedSubjects();

            if ($Clean['ClassSubjectID'] > 0) 
            {
                $NewRecordValidator->ValidateInSelect($Clean['ClassSubjectID'], $ClassSubjectsList, 'Please select a valid subject');
            }

		}

        if ($Clean['ExamTypeID'] > 0) 
        {
            $NewRecordValidator->ValidateInSelect($Clean['ExamTypeID'], $ExamTypeList, 'Please select a exam type.');
        }

        if ($NewRecordValidator->HasNotifications())
        {
            $HasErrors = true;
            break;
        }
        
        $PassPercentage = 40;
        
        if($Clean['ClassID'] > 8)
        {
            $PassPercentage = 34;
        }
        
         $TotalStudents = StudentDetail::GetStudentsByClassSectionID($Clean['ClassSectionID'], 'Active');

        //set record filters        
        $Filters['ClassID'] = $Clean['ClassID'];
        $Filters['ClassSectionID'] = $Clean['ClassSectionID'];
        $Filters['ExamTypeID'] = $Clean['ExamTypeID']; 
        $Filters['ClassSubjectID'] = $Clean['ClassSubjectID'];       

        //get records count
        StudentExamMark::SearchFailStudentDetails($TotalRecords, true, $Filters);

        if ($TotalRecords > 0)
        {
            // Paging and sorting calculations start here.
            $TotalPages = (($TotalRecords % $Limit) == 0) ? $TotalRecords / $Limit : floor($TotalRecords / $Limit) + 1;

            if (isset($_GET['CurrentPage']))
            {
                $Clean['CurrentPage'] = (int) $_GET['CurrentPage'];
            }
            
            if (isset($_GET['AllRecords']))
            {
                $Clean['AllRecords'] = (string) $_GET['AllRecords'];
            }
            
            if ($Clean['CurrentPage'] <= 0)
            {
                $Clean['CurrentPage'] = 1;
            }
            elseif ($Clean['CurrentPage'] > $TotalPages)
            {
                $Clean['CurrentPage'] = $TotalPages;
            }

            if ($Clean['CurrentPage'] > 1)
            {
                $Start = ($Clean['CurrentPage'] - 1) * $Limit;
            }
            // end of Paging and sorting calculations.
            // now get the actual  records
            if ($Clean['AllRecords'] == 'All') 
            {
                $AllFailStudents = StudentExamMark::SearchFailStudentDetails($TotalRecords, false, $Filters, 0, $TotalRecords);
            }
            else
            {
             $AllFailStudents = StudentExamMark::SearchFailStudentDetails($TotalRecords, false, $Filters, $Start, $Limit);   
            }
            
        }
        break;
}

$LandingPageMode = '';
if (isset($_GET['Mode']))
{
    $LandingPageMode = $_GET['Mode'];
}

require_once('../html_header.php');
?>
<title>Fail Students Status Report</title>
<!-- DataTables CSS -->
<link href="../vendor/datatables-plugins/dataTables.bootstrap.css" rel="stylesheet">

<!-- DataTables Responsive CSS -->
<link href="../vendor/datatables-responsive/dataTables.responsive.css" rel="stylesheet">
</head>

<body>

    <div id="wrapper">
    	<!-- Navigation -->
        <nav class="navbar navbar-default navbar-static-top" role="navigation" style="margin-bottom: 0">
<?php 
			require_once('../site_header.php');
			require_once('../left_navigation_menu.php');
?>                    
            <!-- /.navbar-static-side -->
        </nav>

        <div id="page-wrapper">
            <div class="row">
                <div class="col-lg-12">
                    <h1 class="page-header">Fail Students Status Report</h1>
                </div>
                <!-- /.col-lg-12 -->
            </div>
            <!-- /.row -->
            <div class="row">
                <div class="col-lg-12">
                    <div class="panel panel-default">
                        <div class="panel-heading">
                            <strong>Filters</strong>
                        </div>
                         <div class="panel-body">
                            <div>
                                <div class="row" >
                                    <div class="col-lg-12">
<?php
                                    if ($HasErrors == true)
                                    {
                                        echo $NewRecordValidator->DisplayErrorsInTable() .'<br />';
                                    }
                                    else if ($LandingPageMode == 'AS')
                                    {
                                        echo '<div class="alert alert-success alert-top-margin">Record saved successfully.</div>';
                                    }
                                    else if ($RecordDeletedSuccessfully == true)
                                    {
                                        echo '<div class="alert alert-danger alert-top-margin">Record deleted successfully.</div>';
                                    }
                                    else if ($LandingPageMode == 'UD')
                                    {
                                        echo '<div class="alert alert-success alert-top-margin">Record updated successfully.</div>';
                                    }
?>
                                        <br>    
                                         <form class="form-horizontal" name="ExamList" id="ExamList" action="fail_students_report.php" method="get">
                                             
                                            <div class="form-group">
                                                <label for="ClassID" class="col-lg-2 control-label">Class</label>
                                                <div class="col-lg-4">
                                                    <select class="form-control" id="Class" name="drdClass">
                                                        <option value="0">-- All Class --</option>
<?php
                                                    foreach ($ClassList as $ClassID => $ClassName)
                                                    {
                                                        echo '<option' . (($Clean['ClassID'] == $ClassID) ? ' selected="selected"' : '') . ' value="' . $ClassID . '">' . $ClassName . '</option>';
                                                    }
?>
                                                    </select>
                                                </div>
                                                <label for="SectionID" class="col-lg-2 control-label">Section</label>
                                                <div class="col-lg-4">
                                                    <select class="form-control" id="ClassSection" name="drdClassSection">
                                                        <option value="0">-- All Section --</option>
<?php
                                                    foreach ($ClassSectionsList as $ClassSectionID => $SectionName)
                                                    {
                                                        echo '<option' . (($Clean['ClassSectionID'] == $ClassSectionID) ? ' selected="selected"' : '') . ' value="' . $ClassSectionID . '">' . $SectionName . '</option>';
                                                    }
?>
                                                    </select>
                                                </div>
                                            </div>
                                          	<div class="form-group">
                                                 <label for="ExamTypeID" class="col-lg-2 control-label">Exam Type</label>
                                                <div class="col-lg-4">
                                                    <select class="form-control" id="ExamTypeID" name="drdExamType">
                                                        <option value="0">-- All Exam Type --</option>
<?php
                                                    foreach ($ExamTypeList as $ExamTypeID => $ExamTypeName)
                                                    {
                                                        echo '<option' . (($Clean['ExamTypeID'] == $ExamTypeID) ? ' selected="selected"' : '') . ' value="' . $ExamTypeID . '">' . $ExamTypeName . '</option>';
                                                    }
?>
                                                    </select>
                                                </div>
					                        	<label for="ClassSubject" class="col-lg-2 control-label">Subject</label>
					                            <div class="col-lg-4">
					                                <select class="form-control" name="drdClassSubject" id="ClassSubject">
					                                        <option value="0" >-- Select Subject --</option>
<?php
					                                        if (is_array($ClassSubjectsList) && count($ClassSubjectsList) > 0)
					                                        {
					                                            foreach ($ClassSubjectsList as $ClassSubjectID => $ClassSubjectDetail) 
					                                            {
					                                                echo '<option ' . ($Clean['ClassSubjectID'] == $ClassSubjectID ? 'selected="selected"' : '') . ' value="' . $ClassSubjectID . '">' . $ClassSubjectDetail['Subject'] . '</option>' ;
					                                            }
					                                        }
?>
					                                </select>
					                            </div>
                   							 </div>
                                             
                                            <div class="form-group">
                                                <div class="col-sm-offset-2 col-lg-10">
                                                    <input type="hidden" name="hdnProcess" value="7"/>  
                                                    <button type="submit" class="btn btn-primary">Search</button>
                                                </div>
                                             </div>
                                        </form>
                                     </div>
                                </div>
                            </div>
                         </div>
                     </div>
                </div>
            </div>
<?php
        if ($Clean['Process'] == 7 && $HasErrors == false)
        {
?>
            <!-- /.row -->
            <div class="row">
                <div class="col-lg-12">
                    <div class="panel panel-default">
                        <div class="panel-heading">
                            <strong>Total Records Returned: <?php echo $TotalRecords; ?></strong>
                        </div>
                        <!-- /.panel-heading -->
                        <div class="panel-body">
                            <div>
                                 <div class="row">
                                    <div class="col-lg-6">
<?php
                                    if ($TotalPages > 1)
                                    {
                                        $AllParameters = array('Process' => '7', 'ClassID' => $Clean['ClassID'], 'ClassSectionID' => $Clean['ClassSectionID'],'ClassSubjectID' => $Clean['ClassSubjectID'], 'ExamTypeID' => $Clean['ExamTypeID']);
                                        echo UIHelpers::GetPager('fail_students_report.php', $TotalPages, $Clean['CurrentPage'], $AllParameters);
                                    }
?>                                        
                                    </div>
                                    <div class="col-lg-6">
                                        <div class="print-btn-container"><button id="PrintButton" type="submit" class="btn btn-primary">Print</button></div>
                                    </div>
                                     <div class="col-lg-12">
                                        <div class="report-heading-container"><strong>Exam Details on <?php echo date('d-m-Y h:i A'); ?></strong></div>
                                </div>
                                </div>
<?php
                            if ($HasErrors == true)
                            {
                                echo $NewRecordValidator->DisplayErrorsInTable();
                            }
?>
                                <div class="row" id="RecordTableHeading">
                                     <div class="row">
                                        <div class="col-lg-12">
                                            <div class="alert alert-success"><strong>
                                                TotalStudents: <?php echo count($TotalStudents);?>                                        
                                                &nbsp;&nbsp;FailStudents: <?php echo $TotalRecords;?>
                                                &nbsp;&nbsp;PassStudents: <?php echo count($TotalStudents) - $TotalRecords;?>
                                                 </strong>
                                             </div>
                                        </div>
                                    </div>  
								</div>
                                <div class="row" id="RecordTable">
                                    <div class="col-lg-12">
                                        <table width="100%" class="table table-striped table-bordered table-hover" id="DataTableRecords">
                                            <thead>
                                                <tr>
                                                    <th>S. No</th>
                                                    <th>Exam Name</th>
                                                    <th>Student Name</th>
                                                    <th>Class</th>
                                                    <th>Max Marks</th>
                                                    <th>Obtained Marks</th>
                                                    <th>Status</th>
                                            </thead>
                                            <tbody>
<?php
                                    if (is_array($AllFailStudents) && count($AllFailStudents) > 0)
                                    {
                                        $Counter = 0;
                                        foreach ($AllFailStudents as $StudentID => $AllFailStudentsDetails)
                                        {
?>
											<tr>
<?php
                                                 $TotalObtainedPercentage = number_format(($AllFailStudentsDetails['Marks'] / $AllFailStudentsDetails['MaximumMarks']) * 100);
                                                 
                                                if ($TotalObtainedPercentage < $PassPercentage) 
                                                {
?>  
                                                    <td><?php echo ++$Counter; ?></td>
                                                    <td><?php echo $AllFailStudentsDetails['ExamName']; ?></td>
                                                    <td><?php echo $AllFailStudentsDetails['FirstName'].' '.$AllFailStudentsDetails['LastName']; ?></td>
                                                    <td><?php echo $AllFailStudentsDetails['Class']; ?></td>
                                                    <td><?php echo $AllFailStudentsDetails['MaximumMarks']; ?></td>
                                                    <td><?php echo $AllFailStudentsDetails['Marks']; ?></td>
                                                    <td class="alert alert-danger" colspan="3">Failed ( <?php echo $TotalObtainedPercentage; ?> % )</td>
<?php
                                                                               
                                                }
?>

											</tr>
<?php
                                        }   
                                    }
?>
                                            </tbody>
                                        </table>
                                    </div>
                                </div>
                            </div>
                            <!-- /.table-responsive -->
                        </div>
                        <!-- /.panel-body -->
                    </div>
                    <!-- /.panel -->
                </div>
                <!-- /.col-lg-12 -->
            </div>

<?php
        }
?>
        </div>
        <!-- /#page-wrapper -->

    </div>
    <!-- /#wrapper -->
<?php
require_once('../footer.php');
?>
<!-- DataTables JavaScript -->
<script src="../vendor/datatables/js/jquery.dataTables.min.js"></script>
<script src="../vendor/datatables-plugins/dataTables.bootstrap.min.js"></script>
<script src="../vendor/datatables-responsive/dataTables.responsive.js"></script>   
<script type="text/javascript">
$(document).ready(function() {
    $("body").on('click', '.delete-record', function()
    {   
        if (!confirm("Are you sure you want to delete this exam?"))
        {
            return false;
        }
    });

    $('#DataTableRecords').DataTable({
        responsive: true,
        bPaginate: false,
        bSort: false,
        searching: false, 
        info: false
    });

    $('#Class').change(function(){

        var ClassID = parseInt($('#Class').val());
        $('#ClassSubject').html('<option value="0">-- Select Subject --</option>');
        
        if (ClassID <= 0)
        {
            $('#ClassSection').html('<option value="0">-- Select Section --</option>');
            return;
        }
        
        $.post("/xhttp_calls/get_sections_by_classs.php", {SelectedClassID:ClassID}, function(data)
        {
            ResultArray = data.split("|*****|");
            
            if (ResultArray[0] == 'error')
            {
                alert (ResultArray[1]);
                return false;
            }
            else
            {
                $('#ClassSection').html('<option value="0">-- Select Section --</option>' + ResultArray[1]);
            }
        });
    });

     $('#ClassSection').change(function(){

        var ClassID = parseInt($('#Class').val());
        $('#ClassSubject').html('<option value="0">-- Select Subject --</option>');
        
        if (ClassID <= 0)
        {
            $('#ClassSection').html('<option value="0">-- Select Section --</option>');
            return;
        }
        
        $.post("/xhttp_calls/get_subjects_by_class.php", {SelectedClassID:ClassID}, function(data)
        {
            ResultArray = data.split("|*****|");
            
            if (ResultArray[0] == 'error')
            {
                alert (ResultArray[1]);
                return false;
            }
            else
            {
                $('#ClassSubject').html('<option value="0">-- Select Subject --</option>' + ResultArray[1]);
            }
        });
    });


});
</script>
<!-- JavaScript To Print A Report -->
<script src="js/print-report.js"></script>
<script src="/admin/js/print-report.js"></script>
</body>
</html>