<?php
set_time_limit(1800);
require_once("../../classes/class.users.php");
require_once("../../classes/class.validation.php");
require_once("../../classes/class.authentication.php");

require_once('../../classes/school_administration/class.students.php');
require_once('../../classes/school_administration/class.student_details.php');
require_once("../../classes/school_administration/class.parent_details.php");
require_once("../../classes/school_administration/class.classes.php");
require_once('../../classes/school_administration/class.class_sections.php');
require_once('../../classes/school_administration/class.academic_years.php');
require_once("../../classes/school_administration/class.section_master.php");

require_once("../../classes/school_administration/class.class_helpers.php");
require_once("../../classes/school_administration/class.grades.php");
require_once("../../classes/academic_supervision/class.student_diaries.php");
require_once("../../classes/school_administration/class.academic_years.php");
require_once("../../classes/school_administration/class.class_attendence.php");

require_once("../../classes/examination/class.exam_types.php");
require_once("../../classes/examination/class.exams.php");

require_once('../../classes/class.helpers.php');

require_once("../../classes/examination/class.student_exam_mark.php");

require_once("../../includes/global_defaults.inc.php");

//1. RECHECK IF THE USER IS VALID //
try {
    $AuthObject = new ApplicationAuthentication;
    $LoggedUser = new User(0, $AuthObject->CheckValidUser());
}

// THIS CATCH BLOCK BUBBLES THE EXCEPTION TO THE BUILT IN 'Exception' CLASS IF THERE ARE ANY UNCAUGHT ERRORS //
catch (ApplicationAuthException $e) {
    header('location:../unauthorized_login_admin.php');
    exit;
} catch (Exception $e) {
    header('location:../unauthorized_login_admin.php');
    exit;
}
// END OF 1. //

$AllGrades = array();
$AllGrades = Grade::GetAllGrades();

$HasErrors = false;

$Clean = array();
$Clean['ClassSectionID'] = 0;
$Clean['SelectedStudents'] = 1;
$Clean['SelectedExamType'] = '';

if ($_SESSION['DB'] == 'addedschools_gms-24-25') {
    echo 'Session 24 - 25';
} else if ($_SESSION['DB'] == 'addedschools_gms-23-24') {
    $Clean['AcademicYearID'] = 4;
} else if ($_SESSION['DB'] == 'addedschools_gms-22-23') {
    $Clean['AcademicYearID'] = 3;
} elseif ($_SESSION['DB'] == 'addedschools_gms-21-22') {
    $Clean['AcademicYearID'] = 2;
} else {
    $Clean['AcademicYearID'] = 1;
}

$Start = 0;
$Limit = 80;

if (isset($_GET['ClassSectionID'])) {
    $Clean['ClassSectionID'] = (int) $_GET['ClassSectionID'];
}

if (isset($_GET['AcademicYearID'])) {
    $Clean['AcademicYearID'] = (int) $_GET['AcademicYearID'];
}

if (isset($_GET['SelectedStudents'])) {
    $Clean['SelectedStudents'] = (string) $_GET['SelectedStudents'];
}

if ($Clean['SelectedStudents'] == '') {
    header('location:admin/error.php');
    exit;
}

if (isset($_GET['SelectedExamType'])) {
    $Clean['SelectedExamType'] = (string) $_GET['SelectedExamType'];
}

$AcademicYear = '';
$AcademicYear = AcademicYear::GetAcademicYearName($Clean['AcademicYearID']);

if ($Clean['SelectedExamType'] == '') {
    echo 'You don\'t have permission for this, please contact school administration.';
        exit;
}

$Clean['SelectedStudentList'] = explode('$', $Clean['SelectedStudents']);
$Clean['SelectedExamTypeList'] = explode(',', $Clean['SelectedExamType']);

foreach ($Clean['SelectedStudentList'] as $key => $StudentID) {
    if (StudentDiary::CheckAccessDenied($StudentID)) {
        echo 'You don\'t have permission for this, please contact school administration.';
        exit;
    }
}

require_once('../html_header.php');
?>

<title>Print Report Card</title>
<!-- DataTables CSS -->
<link href="../vendor/datatables-plugins/dataTables.bootstrap.css" rel="stylesheet">

<!-- DataTables Responsive CSS -->
<link href="../vendor/datatables-responsive/dataTables.responsive.css" rel="stylesheet">
</head>

<body>
    <div id="wrapper">
        <!-- Navigation -->


        <div>
            <div class="row">
                <div class="col-lg-12">

                </div>
                <!-- /.col-lg-12 -->
            </div>
            <!-- /.row -->
            <div class="row">
                <div class="col-lg-12">
                    <div class="panel panel-default">
                        <!-- /.panel-heading -->
                        <div class="panel-body">
                            <div>
                                <div class="row">
                                    <div class="col-lg-12" style="text-align: right;">
                                        <div class="print-btn-container"><button id="PrintButton" type="submit" class="btn btn-primary">Print All</button></div>
                                    </div>
                                </div>
                                <div class="row" id="RecordTable" style="page-break-before: always;">
                                    <?php

                                    foreach ($Clean['SelectedStudentList'] as $key => $StudentID) {
                                        try {
                                            $CurrentStudent = new StudentDetail($StudentID);
                                            $CurrentParent = new ParentDetail($CurrentStudent->GetParentID());

                                            if ($Clean['ClassSectionID'] <= 0) {
                                                $Clean['ClassSectionID'] = $CurrentStudent->GetClassSectionID();
                                            }
                                        } catch (ApplicationDBException $e) {
                                            header('location:admin/error.php');
                                            exit;
                                        } catch (Exception $e) {
                                            header('location:admin/error.php');
                                            exit;
                                        }

                                        foreach ($Clean['SelectedExamTypeList'] as $ExamTypeID) {
                                            try {
                                                $ExamTypeToEdit = new ExamType($ExamTypeID);
                                            } catch (ApplicationDBException $e) {
                                                header('location:/admin/error.php');
                                                exit;
                                            } catch (Exception $e) {
                                                header('location:/admin/error.php');
                                                exit;
                                            }
                                        }

                                        $AllHappendedExamList = array();
                                        $AllHappendedExamList = Exam::GetAllExamsForReportCard($Clean['ClassSectionID'], false, $Clean['SelectedExamType']);

                                        try {
                                            $CurrentClassSections = new ClassSections($Clean['ClassSectionID']);
                                            $CurrentClass = new AddedClass($CurrentClassSections->GetClassID());

                                            $NextClassName = '';

                                            if ($CurrentClassSections->GetClassID() < 11) {
                                                $NextClass = new AddedClass($CurrentClassSections->GetClassID() + 1);

                                                $NextClassName = $NextClass->GetClassName();
                                            } else {
                                                $NextClassName = '9';
                                            }
                                        } catch (ApplicationDBException $e) {
                                            header('location:admin/error.php');
                                            exit;
                                        } catch (Exception $e) {
                                            header('location:admin/error.php');
                                            exit;
                                        }

                                        $CurrentClass->FillAssignedSubjects();

                                        $AllClassSubjects = array();
                                        $AllClassSubjects = $CurrentClass->GetAssignedSubjects();

                                        try {
                                            $CurrentSectionMaster = new SectionMaster($CurrentClassSections->GetSectionMasterID());
                                        } catch (ApplicationDBException $e) {
                                            header('location:admin/error.php');
                                            exit;
                                        } catch (Exception $e) {
                                            header('location:admin/error.php');
                                            exit;
                                        }
                                    ?>

                                        <div class="row">
                                            <div class="col-lg-3 col-md-3 col-3 col-sm-3 col-xs-3" id="left_head">
                                                <img height="65px;" width="100px;" style="margin-top: 10px; margin-left: 50px;" src="../../site_images/school_logo/school_logo.jpeg" id="logo">
                                            </div>
                                            <div class="col-lg-6 col-md-6 col-6 col-sm-6 col-xs-6">
                                                <div style="float:left; text-align:center;">
                                                    <span style="font-weight: bold;font-size: 20px; white-space: nowrap;">&nbsp;GRACE MODERN JUNIOR HIGH SCHOOL</span><br>
                                                    <span style="font-weight: bold;font-size: 12px;">&nbsp;&nbsp;&nbsp;CIVIL LINES, SITAPUR</span><br>
                                                    <span style="font-weight: bold;font-size: 12px;">&nbsp;&nbsp;&nbsp;ENGLISH MEDIUM - RECOGNISED</span><br>
                                                    <span style="font-weight: bold;font-size: 13px;">&nbsp;&nbsp;PROGRESS REPORT : &nbsp;<?php echo $AcademicYear; ?></span><br>
                                                    <span style="font-weight: bold;font-size: 13px;">;&nbsp;&nbsp;Roll. No. : &nbsp;<?php echo $CurrentStudent->GetRollNumber();  ?></span>
                                                </div>
                                            </div>
                                            <div class="col-lg-3 col-md-3 col-3 col-sm-3 col-xs-3"></div>
                                        </div>
                                        <div class="col-lg-12">
                                            <table width="100%" border="0">
                                                <thead>
                                                    <tr>
                                                        <th>STUDENT'S NAME :<span style="font-weight: normal;">&nbsp;<?php echo $CurrentStudent->GetFirstName() . ' ' . $CurrentStudent->GetLastName(); ?></span></th>
                                                        <th></th>
                                                        <th style="text-align: left;"><span style="width: 30%; margin-left: 20%;">CLASS</span>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;:&nbsp;<span style="width: 40%; font-weight: normal;"><?php echo $CurrentClass->GetClassName() . ' - ' . $CurrentSectionMaster->GetSectionName(); ?>&nbsp;&nbsp;</span></th>
                                                    </tr>
                                                    <tr>
                                                        <th>FATHER'S NAME &nbsp;&nbsp;&nbsp;:<span style="font-weight: normal;">&nbsp;<?php echo $CurrentParent->GetFatherFirstName() . ' ' . $CurrentParent->GetFatherLastName(); ?></span></th>
                                                        <th></th>
                                                        <!--<th style="text-align: left;"><span style="width: 30%; margin-left: 20%">SCHOLAR NO.</span>&nbsp;&nbsp;&nbsp;:&nbsp;<span style="width: 50%; font-weight: normal;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</span></th>-->
                                                        <th style="text-align: left;"><span style="width: 30%; margin-left: 20%">SCHOLAR NO.</span>&nbsp;&nbsp;&nbsp;:&nbsp;<span style="width: 50%; font-weight: normal;"><?php echo $CurrentStudent->GetEnrollmentID(); ?>
                                                                &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</span></th>
                                                    </tr>
                                                    <tr>
                                                        <th>MOTHER'S NAME &nbsp;&nbsp;:<span style="font-weight: normal;">&nbsp;<?php echo $CurrentParent->GetMotherFirstName() . ' ' . $CurrentParent->GetMotherLastName(); ?></span></th>
                                                        <th></th>
                                                        <th style="text-align: left;"><span style="width: 30%; margin-left: 20%">DATE OF BIRTH</span>&nbsp;:&nbsp;<span style="width: 50%; font-weight: normal;  margin-right: 5%;"><?php echo ($CurrentStudent->GetDOB() != '0000-00-00') ? date('d/m/Y', strtotime($CurrentStudent->GetDOB())) : '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'; ?></span></th>
                                                    </tr>
                                                </thead>
                                            </table>
                                            <table width="100%" border="1">
                                                <thead>

                                                    <tr>
                                                        <th>SN</th>
                                                        <?php
                                                        if ($CurrentClassSections->GetClassID() <= 8) {
                                                            echo '<th>&nbsp;&nbsp;&nbsp;SUBJECT Pass marks = 20 (MM 50)</th>';
                                                        } else {
                                                            echo '<th>&nbsp;&nbsp;&nbsp;SUBJECT Pass marks = 17 (MM 50)</th>';
                                                        }
                                                        ?>

                                                        <?php
                                                        foreach ($AllHappendedExamList as $ExamTypeID => $Details) {
                                                        ?>
                                                            <th style="text-align: center;"><?php echo $Details['ExamName']; ?></th>
                                                        <?php
                                                        }
                                                        ?>
                                                        <th style="text-align: center;">Grand Total</th>
                                                    </tr>
                                                    <tr>
                                                        <th></th>
                                                        <th>Max. Marks Totals</th>
                                                        <?php
                                                        $AllSubjectsGrandTotalMaximumMarks = 0;
                                                        foreach ($Clean['SelectedExamTypeList'] as $ExamTypeID) {
                                                            $ExamTypeMaximumMarks = 0;

                                                            foreach ($AllClassSubjects as $ClassSubjectID => $ClassSubjectDetails) {
                                                                $SubjectMarks = StudentExamMark::GetStudentSubjectMarks($ExamTypeID, $ClassSubjectID, $StudentID, $Clean['AcademicYearID']);

                                                                foreach ($SubjectMarks as $key => $SubjectMarksDetails) {

                                                                    if ($ClassSubjectDetails['SubjectMarksType'] == 'Number') {
                                                                        $ExamTypeMaximumMarks += $SubjectMarksDetails['MaximumMarks'];
                                                                    }
                                                                }
                                                            }
                                                            $AllSubjectsGrandTotalMaximumMarks += $ExamTypeMaximumMarks;

                                                            if ($ExamTypeMaximumMarks > 0) {
                                                                echo '<td style="text-align: center;"><strong>' . $ExamTypeMaximumMarks . '</strong></td>';
                                                            } else {
                                                                echo '<td style="text-align: center;"><strong>-</strong></td>';
                                                            }
                                                        }
                                                        ?>
                                                        <th style="text-align: center;"><?php echo $AllSubjectsGrandTotalMaximumMarks; ?></th>
                                                    </tr>

                                                    <?php
                                                    $RowCounter = 1;
                                                    $AllSubjectsGrandTotalObtainedMarks = 0;
                                                    $IsFailInExamType = array();
                                                    $MininumMarks = 0;
                                                    $OverAllMininumMarks = 0;
                                                    $IsFailInGrandTotal = 0;

                                                    foreach ($AllClassSubjects as $ClassSubjectID => $ClassSubjectDetails) {
                                                        if ($ClassSubjectDetails['SubjectMarksType'] == 'Grade') {
                                                            continue;
                                                        }
                                                    ?>
                                                        <tr>
                                                            <td style="text-align: center;"><?php echo $RowCounter++; ?></td>
                                                            <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $ClassSubjectDetails['Subject']; ?></td>
                                                            <?php
                                                            $SubjectObtainedMarksGrandTotal = 0;
                                                            $SubjectMaximumMarksGrandTotal = 0;

                                                            foreach ($Clean['SelectedExamTypeList'] as $ExamTypeID) {

                                                                $SubjectMarks = StudentExamMark::GetStudentSubjectMarks($ExamTypeID, $ClassSubjectID, $StudentID, $Clean['AcademicYearID']);

                                                                if (count($SubjectMarks) == 0) {
                                                                    echo '<td style="text-align: center;">-</td>';
                                                                } else {
                                                                    foreach ($SubjectMarks as $key => $SubjectMarksDetails) {

                                                                        if ($SubjectMarksDetails['Status'] != '' && $SubjectMarksDetails['Status'] != 'Present' && $ClassSubjectDetails['SubjectMarksType'] == 'Number') {
                                                                            echo '<td style="text-align: center;">';
                                                                            echo $SubjectMarksDetails['Status'];
                                                                            echo '</td>';
                                                                        } elseif ($ClassSubjectDetails['SubjectMarksType'] == 'Number') {
                                                                            echo '<td style="text-align: center;">';
                                                                            // echo $SubjectMarksDetails['Marks'] .'/'. $SubjectMarksDetails['MaximumMarks'];

                                                                            if ($CurrentClassSections->GetClassID() <= 8) {
                                                                                $MininumMarks = 20;
                                                                                $OverAllMininumMarks = 80;

                                                                                if ($SubjectMarksDetails['Marks'] < 20) {
                                                                                    $IsFailInExamType[$ExamTypeID] = 1;
                                                                                    echo '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . (int) $SubjectMarksDetails['Marks'] . '<span style="color:red;">&nbsp; (F) </span>';
                                                                                } else {
                                                                                    echo (int) $SubjectMarksDetails['Marks'] . '<span style="color:red;"></span>';
                                                                                }
                                                                            }

                                                                            if ($CurrentClassSections->GetClassID() > 8) {
                                                                                $MininumMarks = 17;
                                                                                $OverAllMininumMarks = 68;

                                                                                if ($SubjectMarksDetails['Marks'] < 17) {
                                                                                    $IsFailInExamType[$ExamTypeID] = 1;
                                                                                    echo '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . (int) $SubjectMarksDetails['Marks'] . '<span style="color:red;">&nbsp; (F) </span>';
                                                                                } else {
                                                                                    echo (int)  $SubjectMarksDetails['Marks'] . '<span style="color:red;"></span>';
                                                                                }
                                                                            }
                                                                            //  echo $SubjectMarksDetails['Marks'];

                                                                            $SubjectObtainedMarksGrandTotal += $SubjectMarksDetails['Marks'];

                                                                            $AllSubjectsGrandTotalObtainedMarks += $SubjectMarksDetails['Marks'];
                                                                            echo '</td>';
                                                                        }
                                                                    }
                                                                }
                                                            }

                                                            if ($SubjectObtainedMarksGrandTotal < $OverAllMininumMarks) {
                                                                $IsFailInGrandTotal = 1;
                                                                echo '<td style="text-align: center;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . $SubjectObtainedMarksGrandTotal . '<span style="color:red;">&nbsp; (F) </span></td>';
                                                            } else {
                                                                echo '<td style="text-align: center;">' . $SubjectObtainedMarksGrandTotal . '</td>';
                                                            }

                                                            //  echo '<td style="text-align: center;">'.$SubjectObtainedMarksGrandTotal;
                                                            ?>
                                                        </tr>
                                                    <?php
                                                    }
                                                    ?>
                                                    <tr>
                                                        <th colspan="2" style="text-align: right;">Grand Total &nbsp;&nbsp;</th>
                                                        <?php
                                                        foreach ($Clean['SelectedExamTypeList'] as $ExamTypeID) {
                                                            $ExamTypeObtainMarks = 0;
                                                            $ExamTypeMaximumMarks = 0;

                                                            foreach ($AllClassSubjects as $ClassSubjectID => $ClassSubjectDetails) {
                                                                $SubjectMarks = StudentExamMark::GetStudentSubjectMarks($ExamTypeID, $ClassSubjectID, $StudentID, $Clean['AcademicYearID']);

                                                                foreach ($SubjectMarks as $key => $SubjectMarksDetails) {

                                                                    if ($ClassSubjectDetails['SubjectMarksType'] == 'Number') {
                                                                        $ExamTypeObtainMarks += $SubjectMarksDetails['Marks'];

                                                                        $ExamTypeMaximumMarks += $SubjectMarksDetails['MaximumMarks'];

                                                                        $ExamTypeMaximumMarks += $SubjectMarksDetails['MaximumMarks'];
                                                                    }
                                                                }
                                                            }

                                                            if ($ExamTypeObtainMarks > 0) {
                                                                // echo '<td style="text-align: center;"><strong>'.$ExamTypeObtainMarks.'/'.$ExamTypeMaximumMarks.'</strong></td>';
                                                                echo '<td style="text-align: center;"><strong>' . $ExamTypeObtainMarks . '</strong></td>';
                                                            } else {
                                                                echo '<td style="text-align: center;"><strong>-</strong></td>';
                                                            }
                                                        }

                                                        echo '<td style="text-align: center;"><strong>'.$AllSubjectsGrandTotalObtainedMarks.'/'.$AllSubjectsGrandTotalMaximumMarks.'</strong></td>';
                                                        // echo '<td style="text-align: center;"><strong>' . $AllSubjectsGrandTotalObtainedMarks . '</strong></td>';
                                                        ?>
                                                    </tr>
                                                    <tr>
                                                        <th colspan="2" style="text-align: right;">Percentage &nbsp;&nbsp;</th>
                                                        <?php
                                                        foreach ($Clean['SelectedExamTypeList'] as $ExamTypeID) {
                                                            $ExamTypeObtainMarks = 0;
                                                            $ExamTypeMaximumMarks = 0;
                                                            $ExamPercentage = 0;

                                                            foreach ($AllClassSubjects as $ClassSubjectID => $ClassSubjectDetails) {
                                                                $SubjectMarks = StudentExamMark::GetStudentSubjectMarks($ExamTypeID, $ClassSubjectID, $StudentID, $Clean['AcademicYearID']);

                                                                foreach ($SubjectMarks as $key => $SubjectMarksDetails) {
                                                                    $TotalMaximumMarks = 0;
                                                                    if ($ClassSubjectDetails['SubjectMarksType'] == 'Number') {
                                                                        $ExamTypeObtainMarks += $SubjectMarksDetails['Marks'];
                                                                        $ExamTypeMaximumMarks += $SubjectMarksDetails['MaximumMarks'];
                                                                    }
                                                                }
                                                            }

                                                            if ($ExamTypeObtainMarks > 0) {
                                                                // echo '<td style="text-align: center;"><strong>'.$ExamTypeObtainMarks . $ExamTypeMaximumMarks.'%</strong></td>';
                                                                echo '<td style="text-align: center;"><strong>' . number_format((($ExamTypeObtainMarks / $ExamTypeMaximumMarks) * 100), 2) . '%</strong></td>';
                                                            } else {
                                                                echo '<td style="text-align: center;"><strong>-</strong></td>';
                                                            }
                                                        }

                                                        if ($AllSubjectsGrandTotalObtainedMarks > 0) {
                                                            echo '<td style="text-align: center;"><strong>' . number_format((($AllSubjectsGrandTotalObtainedMarks / $AllSubjectsGrandTotalMaximumMarks) * 100), 2) . '%</strong></td>';
                                                        } else {
                                                            echo '<td style="text-align: center;"><strong>-</strong></td>';
                                                        }
                                                        ?>
                                                    </tr>
                                                    <tr>
                                                        <th colspan="2" style="text-align: right;">Rank &nbsp;&nbsp;</th>
                                                        <?php
                                                        foreach ($Clean['SelectedExamTypeList'] as $ExamTypeID) {
                                                            $ExamTypeObtainMarks = 0;
                                                            $ExamTypeMaximumMarks = 0;
                                                            $ExamPercentage = 0;

                                                            foreach ($AllClassSubjects as $ClassSubjectID => $ClassSubjectDetails) {
                                                                $SubjectMarks = StudentExamMark::GetStudentSubjectMarks($ExamTypeID, $ClassSubjectID, $StudentID, $Clean['AcademicYearID']);
                                                                $ExamTypeMaximumMarks += $SubjectMarksDetails['MaximumMarks'];

                                                                foreach ($SubjectMarks as $key => $SubjectMarksDetails) {
                                                                    $TotalMaximumMarks = 0;

                                                                    if ($ClassSubjectDetails['SubjectMarksType'] == 'Number') {

                                                                        $ExamTypeObtainMarks += $SubjectMarksDetails['Marks'];
                                                                        // error_log($SubjectMarksDetails['MaximumMarks'].'<br>');
                                                                    }
                                                                }
                                                            }

                                                            if ($ExamTypeObtainMarks > 0) {
                                                                // error_log('**********<br>');
                                                                if (array_key_exists($ExamTypeID, $IsFailInExamType)) {
                                                                    echo '<td style="text-align: center;"><strong><span style="color:red;">Failed</span></strong></td>';
                                                                } else {
                                                                    echo '<td style="text-align: center;"> ' . ((($ExamTypeObtainMarks / $ExamTypeMaximumMarks) * 100) >= $MininumMarks ? StudentExamMark::GetStudentRankInClass($ExamTypeID, $Clean['ClassSectionID'], $MininumMarks, $StudentID, $Clean['AcademicYearID'], false) : '') . ' ';
                                                                    echo '<strong>' . ((($ExamTypeObtainMarks / $ExamTypeMaximumMarks) * 100) >= $MininumMarks ? 'Passed' : '<span style="color:red;">Failed</span>') . '</strong></td>';
                                                                }
                                                                // error_log($ExamTypeObtainMarks);
                                                                // error_log($ExamTypeMaximumMarks);
                                                                // error_log(($ExamTypeObtainMarks / $ExamTypeMaximumMarks) * 100);
                                                            } else {
                                                                echo '<td style="text-align: center;"><strong>-</strong></td>';
                                                            }
                                                        }

                                                        // echo '<td style="text-align: center;"><strong>-</strong></td>';

                                                        $OverAllRank = '';
                                                        $PromotedText = '';

                                                        if ($AllSubjectsGrandTotalObtainedMarks > 0) {
                                                            if ((($AllSubjectsGrandTotalObtainedMarks / $AllSubjectsGrandTotalMaximumMarks) * 100) >= $MininumMarks) {
                                                                $OverAllRank = StudentExamMark::GetStudentRankInClass($ExamTypeID, $Clean['ClassSectionID'], $MininumMarks, $StudentID, $Clean['AcademicYearID'], true);

                                                                $PromotedText = 'PASSED AND PROMOTED TO CLASS ' . $NextClassName;
                                                            } else {
                                                                $PromotedText = 'Failed';
                                                            }

                                                            echo '<td style="text-align: center;">' . ((((($AllSubjectsGrandTotalObtainedMarks / $AllSubjectsGrandTotalMaximumMarks) * 100) >= $MininumMarks) && $IsFailInGrandTotal <= 0) ? $OverAllRank . '<strong> Passed' : '<strong><span style="color:red;">Failed</span>') . '</strong></td>';
                                                        } else {
                                                            echo '<td style="text-align: center;"><strong>-</strong></td>';
                                                        }

                                                        // echo '<td style="text-align: center;"><strong></strong></td>';
                                                        ?>
                                                    </tr>
                                                    <tr>
                                                        <?php

                                                        $StudentRemarkList = array();
                                                        $StudentRemarkList = ExamType::GetStudentExamRemarks(4, $Clean['ClassSectionID']); // 4 for Anual Exam
                                                        $StudentExamRemark = '';

                                                        if (count($StudentRemarkList) > 0) {
                                                            $StudentExamRemark = $StudentRemarkList[$StudentID];
                                                        }
                                                        if (!empty($StudentExamRemark)) {
                                                        ?>
                                                            <td colspan="<?php echo count($Clean['SelectedExamTypeList']) + 3; ?>" studentID="<?php echo  $StudentID; ?>" class="unique-function" style="text-align: right; padding-right: 15px;"><b>&nbsp; <?php echo $StudentExamRemark; ?> </b></td>
                                                        <?php } else { ?>
                                                            <td colspan="<?php echo count($Clean['SelectedExamTypeList']) + 3; ?>" studentID="<?php echo  $StudentID; ?>" class="unique-function" style="text-align: right; padding-right: 15px;"><b>&nbsp; <?php echo $PromotedText; ?></b></td>
                                                        <?php } ?>
                                                    </tr>
                                                </thead>
                                            </table>

                                            <!-- ****************Greade Subject -->
                                            <?php
                                            if ($CurrentClassSections->GetClassID() > 3) {
                                            ?>
                                                <table width="100%" border="1" style="font-size: 13px;margin-top: 8px;">
                                                    <thead>
                                                        <tr style="text-align: center;">
                                                            <td colspan="<?php echo count($AllHappendedExamList) + 3; ?>"><strong>GRADE SUBJECTS</strong></td>
                                                        </tr>
                                                        <tr>
                                                            <th>SN</th>
                                                            <th>&nbsp;&nbsp;&nbsp;GRADE SUBJECTS</th>
                                                            <?php
                                                            foreach ($AllHappendedExamList as $ExamTypeID => $Details) {
                                                            ?>
                                                                <th style="text-align: center;"><?php echo $Details['ExamName']; ?></th>
                                                            <?php
                                                            }
                                                            ?>
                                                            <th style="text-align: center;">Remarks</th>
                                                        </tr>
                                                        <?php
                                                        $RowCounter = 1;
                                                        foreach ($AllClassSubjects as $ClassSubjectID => $ClassSubjectDetails) {
                                                            if ($ClassSubjectDetails['SubjectMarksType'] != 'Grade') {
                                                                continue;
                                                            }
                                                        ?>
                                                            <tr>
                                                                <td style="text-align: center;"><?php echo $RowCounter++; ?></td>
                                                                <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $ClassSubjectDetails['Subject']; ?></td>
                                                                <?php
                                                                $SubjectObtainedMarksGrandTotal = 0;
                                                                $SubjectMaximumMarksGrandTotal = 0;

                                                                foreach ($Clean['SelectedExamTypeList'] as $ExamTypeID) {
                                                                    $SubjectMarks = StudentExamMark::GetStudentSubjectMarks($ExamTypeID, $ClassSubjectID, $StudentID, $Clean['AcademicYearID']);

                                                                    if (count($SubjectMarks) == 0) {
                                                                        echo '<td style="text-align: center;">-</td>';
                                                                    } else {
                                                                        foreach ($SubjectMarks as $key => $SubjectMarksDetails) {
                                                                            if ($ClassSubjectDetails['SubjectMarksType'] == 'Grade') {
                                                                                echo '<td style="text-align: center;">';
                                                                                echo $SubjectMarksDetails['Grade'];
                                                                                echo '</td>';
                                                                            }
                                                                        }
                                                                    }
                                                                }
                                                                ?>
                                                                <td>&nbsp;</td>
                                                            </tr>
                                                        <?php
                                                        }

                                                        // if ($CurrentClassSections->GetClassID() == 11)
                                                        // {
                                                        // $ClubActivities = ClassHelpers::GetStudentClubActivities($StudentID);

                                                        // echo '<tr style="height: 30px; font-size:12px;">';
                                                        //     echo '<th colspan="7" class="unique-function" studentID="'. $StudentID .'" style="padding-left: 10px;"> CLUB ACTIVITIES: '. $ClubActivities .'</th>';
                                                        // echo '</tr>';
                                                        //}
                                                        ?>
                                                    </thead>
                                                </table>
                                            <?php
                                            }
                                            ?>
                                            <table width="100%" border="1" style="margin-top: 8px;">
                                                <?php
                                                $CurrentAcademicYearName = '';
                                                $StartDate = '2022-04-01';

                                                // AcademicYear::GetPreviousAcademicYear($CurrentAcademicYearName, $StartDate, $EndDate);

                                                $HalfYearlyPhysiqueDetails = $CurrentStudent->FillStudentHeightWeight(2);
                                                $AnnualPhysiqueDetails = $CurrentStudent->FillStudentHeightWeight(4);

                                                $ExamTypeDetails = ExamType::GetAllExamTypes();
                                                $TotalHalfYearlyWorkingDays = 0;
                                                $TotalAnnualWorkingDays = 0;

                                                $HalfYearlyWorkingDaysStartDate = $ExamTypeDetails[2]['ExamStartDate'];
                                                $HalfYearlyWorkingDaysEndDate = $ExamTypeDetails[2]['ExamEndDate'];

                                                if ($HalfYearlyWorkingDaysStartDate != '0000-00-00') {
                                                    $HalfYearlyWokingDays = Helpers::GetClassWorkingDays($StartDate, $HalfYearlyWorkingDaysEndDate, $Clean['ClassSectionID']);

                                                    $TotalHalfYearlyWorkingDays = count($HalfYearlyWokingDays);
                                                }

                                                $Filters['StudentID'] = $StudentID;
                                                $Filters['FromDate'] = $StartDate;
                                                $Filters['ToDate'] = $HalfYearlyWorkingDaysEndDate;
                                                $Filters['AcademicYearID'] = $Clean['AcademicYearID'];

                                                $HalfYearlyAttendenceDetails = ClassAttendence::SearchClassAttendence($TotalRecords, false, $Filters, $Start, $Limit, $TotalHalfYearlyWorkingDays);

                                                $AnnualWorkingDaysStartDate = $ExamTypeDetails[4]['ExamStartDate'];

                                                // $AnnualWorkingDaysEndDate = $ExamTypeDetails[4]['ExamEndDate'];    
                                                if ($CurrentClassSections->GetClassID() == '1' || $CurrentClassSections->GetClassID() == '2' || $CurrentClassSections->GetClassID() == '3') {
                                                    $AnnualWorkingDaysEndDate = '2024-03-03';
                                                } else {
                                                    $AnnualWorkingDaysEndDate = '2024-03-06';
                                                }
                                                if ($AnnualWorkingDaysStartDate != '0000-00-00') {
                                                    $AnnualWokingDays = Helpers::GetClassWorkingDays($StartDate, $AnnualWorkingDaysEndDate, $Clean['ClassSectionID']);

                                                    $TotalAnnualWorkingDays = count($AnnualWokingDays);
                                                }

                                                // var_dump($CurrentClassSections->GetClassID());
                                                $Filters['StudentID'] = $StudentID;
                                                $Filters['FromDate'] = $StartDate;
                                                if ($CurrentClassSections->GetClassID() == '1' || $CurrentClassSections->GetClassID() == '2' || $CurrentClassSections->GetClassID() == '3') {
                                                    $Filters['ToDate'] = '2024-03-03';
                                                } else {
                                                    $Filters['ToDate'] = '2024-03-06';
                                                }

                                                if ($CurrentClassSections->GetClassID() == '1' || $CurrentClassSections->GetClassID() == '2' || $CurrentClassSections->GetClassID() == '3') {
                                                    $TotalHalfWorkingDays = 89;
                                                } else {
                                                    $TotalHalfWorkingDays = 91;
                                                }
                                                
                                                if ($CurrentClassSections->GetClassID() == '1' || $CurrentClassSections->GetClassID() == '2' || $CurrentClassSections->GetClassID() == '3') {
                                                    $TotalAnnualWorkingDays = 194;
                                                } else {
                                                    $TotalAnnualWorkingDays = 196;
                                                }

                                                // $Filters['AttendanePercentRangeFrom'] = $AnnualWorkingDaysStartDate;
                                                // $Filters['AttendanePercentRangeTo'] = $AnnualWorkingDaysEndDate;$TotalHalfYearlyWorkingDays

                                                $AnnualAttendenceDetails = ClassAttendence::SearchClassAttendence($TotalRecords, false, $Filters, $Start, $Limit, $TotalAnnualWorkingDays);

                                                ?>
                                                <tr style="font-weight: bold;">
                                                    <td style=";width: 200px;height:20px;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Half Yearly Exam : </td>
                                                    <td>&nbsp;&nbsp;&nbsp;Height : <?php echo array_key_exists('Height', $HalfYearlyPhysiqueDetails) ? ($HalfYearlyPhysiqueDetails['Height']) . '(cm)' : '--'; ?></td>
                                                    <td>&nbsp;&nbsp;&nbsp;Weight : <?php echo array_key_exists('Weight', $HalfYearlyPhysiqueDetails) ? ($HalfYearlyPhysiqueDetails['Weight']) . '(kg)' : '--'; ?></td>
                                                    <td>&nbsp;&nbsp;&nbsp;Attendance : <?php echo (true) ? ($HalfYearlyAttendenceDetails[$StudentID]['TotalPresentDays'] . '/' . $TotalHalfWorkingDays) : '--'; ?></td>
                                                </tr>
                                                <tr style="font-weight: bold;">
                                                    <td style="font-weight: bold;width: 200px;height:20px;">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Annual Exam : </td>
                                                    <td>&nbsp;&nbsp;&nbsp;Height : <?php echo array_key_exists('Height', $AnnualPhysiqueDetails) ? ($AnnualPhysiqueDetails['Height']) . '(cm)' : '--'; ?></td>
                                                    <td>&nbsp;&nbsp;&nbsp;Weight : <?php echo array_key_exists('Weight', $AnnualPhysiqueDetails) ? ($AnnualPhysiqueDetails['Weight']) . '(kg)' : '--'; ?></td>
                                                    <td>&nbsp;&nbsp;&nbsp;Attendance : <?php echo (true) ? ($AnnualAttendenceDetails[$StudentID]['TotalPresentDays'] . '/' .  $TotalAnnualWorkingDays) : '--'; ?></td>
                                                </tr>

                                            </table>



                                            <!-- <hr style="border-top: dotted 1px;">
                                        <table width="100%" border="0">
                                            <thead>
                                                <tr height="40px"><th colspan="3" style="text-align: right;">Promoted To ___</th></tr>
                                                <tr>
                                                    <th>Attedance &nbsp;:<span style="font-weight: normal;">__</span></th>
                                                </tr>
                                                <tr>
                                                    <th>Health &nbsp;:<span style="font-weight: normal;">____</span></th>
                                                </tr>
                                                <tr>
                                                    <th>Conduct &nbsp;:<span style="font-weight: normal;">______</span></th>
                                                </tr>
                                                <tr>
                                                    <th>Remark &nbsp;:<span style="font-weight: normal;">_________</span></th>
                                                </tr>
                                            </thead>
                                        </table> -->
                                            <div style="margin-top: 15px; width: 700px;">
                                                <?php
                                                if ($CurrentClassSections->GetClassID() > 3 && $CurrentClassSections->GetClassID() < 9) {
                                                    echo '<div style="float:left; height: 20px; margin-top: 15px; margin-left:280px;" ><b>Head Mistress`s Remarks: </b>_____________________________</div>';
                                                } else {
                                                    echo '<div style="float:left; height: 20px; margin-top: 15px;  margin-left:280px;" ><b>Head Master`s Remarks: </b>_____________________________</div>';
                                                }
                                                ?>
                                            </div><br>
                                            <div style="margin-top: 15px; width: 700px;">

                                                <div style="float:left; height: 20px; margin-top: 15px;"><b>Class Teacher's Sign &nbsp;&nbsp;</b></div>
                                                <div style="float:left; width: 150px; height: 30px; margin-top: 15px;">__________________</div>
                                                <?php
                                                if ($CurrentClassSections->GetClassID() > 3 && $CurrentClassSections->GetClassID() < 9) {
                                                    echo '<div style="float:left; height: 20px; margin-top: 15px;" ><b>Head Mistress`s Sign &nbsp;</b></div>';
                                                    echo ' <div style="float:left; border: 1px solid black; width: 220px; height: 45px; margin-top: 15px;">
                                              
                                            </div>';
                                                } else {
                                                    echo '<div style="float:left; height: 20px; margin-top: 15px;" ><b>Head Master`s Sign &nbsp;</b></div>';
                                                    echo ' <div style="float:left; border: 1px solid black; width: 220px; height: 45px; margin-top: 15px;">
                                               
                                            </div>';
                                                }
                                                ?>
                                                <!--<div style="float:left; border: 1px solid black; width: 220px; height: 35px; margin-top: 15px;"></div>-->
                                                <!--<div style="float:left; width: 150px; height: 30px; margin-top: 15px;">__________________</div>-->
                                            </div>
                                            <div style="margin-top: 15px; width: 700px;">
                                                <div style="float:left; height: 20px; margin-top: 15px;"><b></b></div>
                                                <div style="float:left; width: 380px; height: 30px; margin-top: 15px;"></div>
                                                <div style="float:left; height: 20px; margin-top: 10px;"><b>Stamp &nbsp;&nbsp;</b></div>
                                                <div style="float:left; border: 1px solid black; width: 255px; height: 50px; margin-top: 15px; margin-bottom: 10px;"></div>
                                            </div>

                                            <?php
                                            if ($CurrentClassSections->GetClassID() > 3) {
                                            ?>
                                                <div class="row" style="margin-top: 5px;">
                                                    <div class="col-lg-12">
                                                        <table width="100%" border="1">
                                                            <thead>
                                                                <?php
                                                                $RowCounter = 0;

                                                                foreach ($AllGrades as $GradeDetails) {
                                                                    if ($RowCounter == 0) {
                                                                        echo '<tr>';
                                                                    }

                                                                    $GradeType = '';
                                                                    if ($GradeDetails['Grade'] == 'A') {
                                                                        $GradeType = 'Excellent';
                                                                    } else if ($GradeDetails['Grade'] == 'B') {
                                                                        $GradeType = 'Satisfactory';
                                                                    } else if ($GradeDetails['Grade'] == 'C') {
                                                                        $GradeType = 'Medium';
                                                                    } else if ($GradeDetails['Grade'] == 'D') {
                                                                        $GradeType = 'Average';
                                                                    } else if ($GradeDetails['Grade'] == 'F') {
                                                                        $GradeType = 'Disappointing';
                                                                    }

                                                                    if ($GradeDetails['Grade'] == '-') {
                                                                        echo '<td>';
                                                                        echo '</td>';
                                                                    } else {
                                                                        echo '<td>';
                                                                        echo '&nbsp;Grade: ' . $GradeDetails['Grade'] . ' (' . $GradeDetails['FromPercentage'] . ' - ' . $GradeDetails['ToPercentage'] . ') (' . $GradeType . ')';
                                                                        // echo '&nbsp;Grade: '.$GradeDetails['Grade'].' (' .$GradeDetails['FromPercentage'] . ' - '.$GradeDetails['ToPercentage'] .')';
                                                                        echo '</td>';
                                                                    }
                                                                    $RowCounter++;

                                                                    if ($RowCounter > 1) {
                                                                        echo '</tr>';
                                                                        $RowCounter = 0;
                                                                    }
                                                                }
                                                                ?>
                                                            </thead>
                                                        </table>
                                                    </div>
                                                </div>
                                            <?php
                                            }
                                            ?>
                                        </div>
                                        <div style="page-break-after: always;"></div>
                                    <?php
                                    }
                                    ?>
                                </div>
                                <!-- /.table-responsive -->
                            </div>
                            <!-- /.panel-body -->
                        </div>
                        <!-- /.panel -->
                    </div>
                    <!-- /.col-lg-12 -->
                </div>
            </div>
            <!-- /#page-wrapper -->
        </div>
        <!-- /#wrapper -->
        <?php
        require_once('../footer.php');
        ?>
        <!-- DataTables JavaScript -->
        <script src="../vendor/datatables/js/jquery.dataTables.min.js"></script>
        <script src="../vendor/datatables-plugins/dataTables.bootstrap.min.js"></script>
        <script src="../vendor/datatables-responsive/dataTables.responsive.js"></script>
        <script type="text/javascript">
            $(document).ready(function() {
                $("body").on('click', '.delete-record', function() {
                    if (!confirm("Are you sure you want to delete this exam?")) {
                        return false;
                    }
                });

                $('#DataTableRecords').DataTable({
                    responsive: true,
                    bPaginate: false,
                    bSort: false,
                    searching: false,
                    info: false
                });

                $('.unique-function').click(function() {

                    var This = $(this);
                    var StudentID = This.attr('studentID');
                    var DataValue = prompt('Enter Details', This.text().trim());

                    var ClubActivities = DataValue;

                    if (ClubActivities) {
                        // $(this).html('&nbsp;&nbsp;<b>' + DataValue + '</b>');

                        $.post("/xhttp_calls/update_student_club_activities.php", {
                            StudentID: StudentID,
                            ClubActivities: ClubActivities
                        }, function(data) {
                            ResultArray = data.split("|*****|");

                            if (ResultArray[0] == 'error') {
                                alert(ResultArray[1]);
                                return false;
                            } else {
                                This.html('&nbsp;&nbsp;<b>' + DataValue + '</b>');
                            }
                        });
                    }
                });
            });
        </script>
        <!-- JavaScript To Print A Report -->
        <script src="js/print-report.js"></script>
        <script src="/admin/js/print-report.js"></script>
</body>

</html>