<?php
require_once("../../classes/class.users.php");
require_once("../../classes/class.validation.php");
require_once("../../classes/class.authentication.php");

require_once('../../classes/school_administration/class.classes.php');
require_once('../../classes/school_administration/class.class_sections.php');
require_once('../../classes/school_administration/class.section_master.php');
require_once("../../classes/school_administration/class.students.php");
require_once("../../classes/school_administration/class.student_details.php");

require_once('../../classes/examination/class.exam_types.php');
require_once('../../classes/examination/class.exams.php');

require_once("../../classes/examination/class.student_exam_mark.php");

require_once('../../classes/class.ui_helpers.php');

require_once('../../includes/helpers.inc.php');
require_once('../../includes/global_defaults.inc.php');

//1. RECHECK IF THE USER IS VALID //
try
{
	$AuthObject = new ApplicationAuthentication;
	$LoggedUser = new User(0, $AuthObject->CheckValidUser());
}

// THIS CATCH BLOCK BUBBLES THE EXCEPTION TO THE BUILT IN 'Exception' CLASS IF THERE ARE ANY UNCAUGHT ERRORS //
catch (ApplicationAuthException $e)
{
	header('location:../unauthorized_login_admin.php');
	exit;
}
catch (Exception $e)
{
	header('location:../unauthorized_login_admin.php');
	exit;
}
// END OF 1. //

if ($LoggedUser->HasPermissionForTask(TASK_EXAM_REPORT_SUMMARY) !== true)
{
	header('location:/admin/unauthorized_login_admin.php');
	exit;
}

$HasErrors = false;
$TotalRecords = 0;

$RecordDeletedSuccessfully = false;

$ClassList =  array();
$ClassList = AddedClass::GetActiveClasses();

$ClassSectionsList =  array();

$ExamTypeList = array();
$ExamTypeList = ExamType::GetActiveExamTypes();

$Clean = array();

$Clean['Process'] = 0;

$Clean['ClassID'] = 0;
$Clean['ClassSectionID'] = 0;
$Clean['ExamTypeID'] = 0;

$Clean['SearchBy'] = 1;

// paging and sorting variables start here  //
$Clean['AllRecords'] = '';
$Clean['CurrentPage'] = 1;
$TotalPages = 0;

$Start = 0;
$Limit = 30;

$MininumMarks = 0;
// end of paging variables //

$ClassSubjectsList = array();
$SubjectWiseFailStudents = array();
$ExamWiseFailStudents = array();

$AllStudentsList = array();
$TotalStudents = array();

if (isset($_GET['hdnProcess']))
{
    $Clean['Process'] = (int) $_GET['hdnProcess'];
}
else if (isset($_GET['Process']))
{
    $Clean['Process'] = (int) $_GET['Process'];
}
switch ($Clean['Process'])
{
    case 7:        
        if (isset($_GET['drdClass']))
        {
            $Clean['ClassID'] = (int) $_GET['drdClass'];
        }
        elseif (isset($_GET['ClassID']))
        {
            $Clean['ClassID'] = (int) $_GET['ClassID'];
        }

        if (isset($_GET['drdClassSection']))
        {
            $Clean['ClassSectionID'] = (int) $_GET['drdClassSection'];
        }

        elseif (isset($_GET['ClassSectionID']))
        {
            $Clean['ClassSectionID'] = (int) $_GET['ClassSectionID'];
        }

        if (isset($_GET['drdExamType']))
        {
            $Clean['ExamTypeID'] = (int) $_GET['drdExamType'];
        }
        elseif (isset($_GET['ExamTypeID']))
        {
            $Clean['ExamTypeID'] = (int) $_GET['ExamTypeID'];
        }
        
        if (isset($_GET['optSearchBy']))
        {
            $Clean['SearchBy'] = (int) $_GET['optSearchBy'];
        }

        $NewRecordValidator = new Validator();
        
      if ($NewRecordValidator->ValidateInSelect($Clean['ClassID'], $ClassList, 'Please select a valid class.')) 
		{
			$ClassSectionsList = ClassSections::GetClassSections($Clean['ClassID']);

            $NewRecordValidator->ValidateInSelect($Clean['ClassSectionID'], $ClassSectionsList, 'Please select a valid section.');

            $SelectedAddedClass = new AddedClass($Clean['ClassID']);
            $SelectedAddedClass->FillAssignedSubjects();
            
            $ClassSubjectsList = $SelectedAddedClass->GetAssignedSubjects();
		}
        
        if ($Clean['SearchBy'] != 3)
        {
            $NewRecordValidator->ValidateInSelect($Clean['ExamTypeID'], $ExamTypeList, 'Please select a exam type.');   
        }

        if ($NewRecordValidator->HasNotifications())
        {
            $HasErrors = true;
            break;
        }
        
         $TotalStudents = StudentDetail::GetStudentsByClassSectionID($Clean['ClassSectionID'], 'Active');
        
        if ($Clean['ClassID'] <= 8)
        {
            $MininumMarks = 20;
        }
        else
        {
            $MininumMarks = 17;
        }
        
        //set record filters        
        $Filters['ClassID'] = $Clean['ClassID'];
        $Filters['ClassSectionID'] = $Clean['ClassSectionID'];
        $Filters['ExamTypeID'] = $Clean['ExamTypeID'];        
        
        if ($Clean['SearchBy'] == 1) // 1 for student wise report and 2 for subject wise
        {
            //get records count
            StudentExamMark::SearchPassStudentDetails($TotalRecords, true, $Filters);
    
            if ($TotalRecords > 0)
            {
                // Paging and sorting calculations start here.
                $TotalPages = (($TotalRecords % $Limit) == 0) ? $TotalRecords / $Limit : floor($TotalRecords / $Limit) + 1;
    
                if (isset($_GET['CurrentPage']))
                {
                    $Clean['CurrentPage'] = (int) $_GET['CurrentPage'];
                }
                
                if (isset($_GET['AllRecords']))
                {
                    $Clean['AllRecords'] = (string) $_GET['AllRecords'];
                }
                
                if ($Clean['CurrentPage'] <= 0)
                {
                    $Clean['CurrentPage'] = 1;
                }
                elseif ($Clean['CurrentPage'] > $TotalPages)
                {
                    $Clean['CurrentPage'] = $TotalPages;
                }
    
                if ($Clean['CurrentPage'] > 1)
                {
                    $Start = ($Clean['CurrentPage'] - 1) * $Limit;
                }
                // end of Paging and sorting calculations.
                // now get the actual  records
                if ($Clean['AllRecords'] == 'All') 
                {
                    $AllStudentsList = StudentExamMark::SearchPassStudentDetails($TotalRecords, false, $Filters, 0, $TotalRecords);
                }
                else
                {
                    $AllStudentsList = StudentExamMark::SearchPassStudentDetails($TotalRecords, false, $Filters, $Start, $Limit);   
                }
            }
        }
        else if($Clean['SearchBy'] == 2)
        {
            //get records count
        
            foreach ($ClassSubjectsList as $ClassSubjectID => $Details)
            {
                $Filters['ClassSubjectID'] = $ClassSubjectID; 
                
                StudentExamMark::SearchFailStudentDetails($TotalRecords, true, $Filters); 
                
                $SubjectWiseFailStudents[$ClassSubjectID] = $TotalRecords;
            }
        }
        
        if ($Clean['SearchBy'] == 3)
        {
            foreach ($ClassSubjectsList as $ClassSubjectID => $Details)
            {
                foreach ($ExamTypeList as $ExamTypeID => $Details)
                {
                    $Filters['ClassSectionID'] = $Clean['ClassSectionID'];
                    $Filters['ExamTypeID'] = $ExamTypeID; 
                    $Filters['ClassSubjectID'] = $ClassSubjectID; 
                    
                    StudentExamMark::SearchFailStudentDetails($TotalRecords, true, $Filters); 
                    
                    $ExamWiseFailStudents[$ClassSubjectID][$ExamTypeID] = $TotalRecords;
                }                
            }
        }
        
        break;
}

$LandingPageMode = '';
if (isset($_GET['Mode']))
{
    $LandingPageMode = $_GET['Mode'];
}

require_once('../html_header.php');
?>
<title>View Exam Report Summary</title>
<!-- DataTables CSS -->
<link href="../vendor/datatables-plugins/dataTables.bootstrap.css" rel="stylesheet">

<!-- DataTables Responsive CSS -->
<link href="../vendor/datatables-responsive/dataTables.responsive.css" rel="stylesheet">
</head>

<body>

    <div id="wrapper">
    	<!-- Navigation -->
        <nav class="navbar navbar-default navbar-static-top" role="navigation" style="margin-bottom: 0">
<?php 
			require_once('../site_header.php');
			require_once('../left_navigation_menu.php');
?>                    
            <!-- /.navbar-static-side -->
        </nav>

        <div id="page-wrapper">
            <div class="row">
                <div class="col-lg-12">
                    <h1 class="page-header">View Exam Report Summary</h1>
                </div>
                <!-- /.col-lg-12 -->
            </div>
            <!-- /.row -->
            <div class="row">
                <div class="col-lg-12">
                    <div class="panel panel-default">
                        <div class="panel-heading">
                            <strong>Filters</strong>
                        </div>
                         <div class="panel-body">
                            <div>
                                <div class="row" >
                                    <div class="col-lg-12">
<?php
                                    if ($HasErrors == true)
                                    {
                                        echo $NewRecordValidator->DisplayErrorsInTable() .'<br />';
                                    }
                                    else if ($LandingPageMode == 'AS')
                                    {
                                        echo '<div class="alert alert-success alert-top-margin">Record saved successfully.</div>';
                                    }
                                    else if ($RecordDeletedSuccessfully == true)
                                    {
                                        echo '<div class="alert alert-danger alert-top-margin">Record deleted successfully.</div>';
                                    }
                                    else if ($LandingPageMode == 'UD')
                                    {
                                        echo '<div class="alert alert-success alert-top-margin">Record updated successfully.</div>';
                                    }
?>
                                        <br>    
                                         <form class="form-horizontal" name="ExamList" id="ExamList" action="view_exam_report_summary.php" method="get">
                                             
                                            <div class="form-group">
                                                <label for="ClassID" class="col-lg-2 control-label">Class</label>
                                                <div class="col-lg-4">
                                                    <select class="form-control" id="Class" name="drdClass">
                                                        <option value="0">-- All Class --</option>
<?php
                                                    foreach ($ClassList as $ClassID => $ClassName)
                                                    {
                                                        echo '<option' . (($Clean['ClassID'] == $ClassID) ? ' selected="selected"' : '') . ' value="' . $ClassID . '">' . $ClassName . '</option>';
                                                    }
?>
                                                    </select>
                                                </div>
                                                <label for="SectionID" class="col-lg-2 control-label">Section</label>
                                                <div class="col-lg-4">
                                                    <select class="form-control" id="ClassSection" name="drdClassSection">
                                                        <option value="0">-- All Section --</option>
<?php
                                                    foreach ($ClassSectionsList as $ClassSectionID => $SectionName)
                                                    {
                                                        echo '<option' . (($Clean['ClassSectionID'] == $ClassSectionID) ? ' selected="selected"' : '') . ' value="' . $ClassSectionID . '">' . $SectionName . '</option>';
                                                    }
?>
                                                    </select>
                                                </div>
                                            </div>
                                          	<div class="form-group">
                                                 <label for="ExamTypeID" class="col-lg-2 control-label">Exam Type</label>
                                                <div class="col-lg-4">
                                                    <select class="form-control" id="ExamTypeID" name="drdExamType">
                                                        <option value="0">-- All Exam Type --</option>
<?php
                                                    foreach ($ExamTypeList as $ExamTypeID => $ExamTypeName)
                                                    {
                                                        echo '<option' . (($Clean['ExamTypeID'] == $ExamTypeID) ? ' selected="selected"' : '') . ' value="' . $ExamTypeID . '">' . $ExamTypeName . '</option>';
                                                    }
?>
                                                    </select>
                                                </div>
                   							</div>
                   							<div class="form-group">
                                                <label for="SearchBy" class="col-lg-2 control-label">Report</label>
                                                <div class="col-lg-9">
                                                    <label class="radio-inline">
                                                        <input type="radio" <?php echo (($Clean['SearchBy'] == 1) ? 'checked="checked"' : ''); ?> name="optSearchBy" value="1">Search Student Wise Report
                                                    </label>
                                                    <label class="radio-inline">
                                                        <input type="radio" <?php echo (($Clean['SearchBy'] == 2) ? 'checked="checked"' : ''); ?> name="optSearchBy" value="2">Search Subject Wise Report
                                                    </label>
                                                    <label class="radio-inline">
                                                        <input type="radio" <?php echo (($Clean['SearchBy'] == 3) ? 'checked="checked"' : ''); ?> name="optSearchBy" value="3">Search Exam Wise Fail Student Report
                                                    </label>
                                                </div>
                                            </div>  
                                             
                                            <div class="form-group">
                                                <div class="col-sm-offset-2 col-lg-5">
                                                    <input type="hidden" name="hdnProcess" value="7"/>  
                                                    <button type="submit" class="btn btn-primary">Search</button>
                                                </div>
                                            </div>
                                            
                                        </form>
                                     </div>
                                </div>
                            </div>
                         </div>
                     </div>
                </div>
            </div>
<?php
        if ($Clean['Process'] == 7 && $HasErrors == false && $Clean['SearchBy'] == 1)
        {
?>
            <!-- /.row -->
            <div class="row">
                <div class="col-lg-12">
                    <div class="panel panel-default">
                        <div class="panel-heading">
                            <strong>Total Records Returned: <?php echo $TotalRecords; ?></strong>
                        </div>
                        <!-- /.panel-heading -->
                        <div class="panel-body">
                            <div>
                                 <div class="row">
                                    <div class="col-lg-6">
<?php
                                    if ($TotalPages > 1)
                                    {
                                        $AllParameters = array('Process' => '7', 'ClassID' => $Clean['ClassID'], 'ClassSectionID' => $Clean['ClassSectionID'], 'ExamTypeID' => $Clean['ExamTypeID']);
                                        echo UIHelpers::GetPager('view_exam_report_summary.php', $TotalPages, $Clean['CurrentPage'], $AllParameters);
                                    }
?>                                        
                                    </div>
                                    <div class="col-lg-6">
                                        <div class="print-btn-container"><button id="PrintButton" type="submit" class="btn btn-primary">Print</button></div>
                                    </div>
                                     <div class="col-lg-12">
                                        <div class="report-heading-container"><strong>Exam Summary Details on <?php echo date('d-m-Y h:i A'); ?></strong></div>
                                </div>
                                </div>
<?php
                            if ($HasErrors == true)
                            {
                                echo $NewRecordValidator->DisplayErrorsInTable();
                            }
?>
                                <div class="row" id="RecordTable">
                                    <div class="col-lg-12">
                                        <table width="100%" class="table table-striped table-bordered table-hover" id="DataTableRecords">
                                            <thead>
                                                <tr>
                                                    <th>S. No</th>
                                                    <th>Student Name</th>
                                                    <th>Class</th>
                                                    <th>Maximum Marks</th>
                                                    <th>Obtained Marks</th>
                                                    <th>Status(Percentage)</th>
                                                    <th>Rank</th>
                                            </thead>
                                            <tbody>
<?php
                                    if (is_array($AllStudentsList) && count($AllStudentsList) > 0)
                                    {
                                        $Counter = 0;
                                        $Rank = 0;
                                        foreach ($AllStudentsList as $StudentID => $AllStudentsListDetails)
                                        {
                                            $Rank = StudentExamMark::GetStudentRankInClass($Clean['ExamTypeID'], $Clean['ClassSectionID'], $MininumMarks, $StudentID);
?>
											<tr>												
<?php
                                                 $TotalObtainedPassPercentage = number_format(($AllStudentsListDetails['Marks'] / $AllStudentsListDetails['MaximumMarks']) * 100, 2);
                                                if ($TotalObtainedPassPercentage >= 40) 
                                                {
?>  
                                                    <td><?php echo ++$Counter; ?></td>
                                                    <td><?php echo $AllStudentsListDetails['FirstName'].' '.$AllStudentsListDetails['LastName']; ?></td>
                                                    <td><?php echo $AllStudentsListDetails['Class']; ?></td>
                                                    <td><?php echo $AllStudentsListDetails['MaximumMarks']; ?></td>
                                                    <td><?php echo $AllStudentsListDetails['Marks']; ?></td>
                                                    <?php
                                                        if ($Rank)
                                                        {
                                                            echo '<td class="alert alert-success">passed ('. $TotalObtainedPassPercentage .' % )</td>';
                                                        }
                                                        else
                                                        {
                                                            echo '<td class="alert alert-warning">Failed/Absent in any subject ( '. $TotalObtainedPassPercentage .' % )</td>';
                                                        }
                                                    ?>
                                                    
                                                    <td><?php echo $Rank; ?></td>
<?php
                                                                               
                                                }  

                                                 $TotalObtainedFailPercentage = number_format(($AllStudentsListDetails['Marks'] / $AllStudentsListDetails['MaximumMarks']) * 100, 2);
                                                if ($TotalObtainedFailPercentage < 40) 
                                                {
?>  
                                                    <td><?php echo ++$Counter; ?></td>
                                                    <td><?php echo $AllStudentsListDetails['FirstName'].' '.$AllStudentsListDetails['LastName']; ?></td>
                                                    <td><?php echo $AllStudentsListDetails['Class']; ?></td>
                                                    <td><?php echo $AllStudentsListDetails['MaximumMarks']; ?></td>
                                                    <td><?php echo $AllStudentsListDetails['Marks']; ?></td>
                                                    <td class="alert alert-danger">Failed ( <?php echo $TotalObtainedFailPercentage; ?> % )</td>
                                                    <td></td>
<?php
                                                                               
                                                }                                              
?>
											</tr>
<?php
                                        }   
                                    }
?>
                                            </tbody>
                                        </table>
                                    </div>
                                </div>
                            </div>
                            <!-- /.table-responsive -->
                        </div>
                        <!-- /.panel-body -->
                    </div>
                    <!-- /.panel -->
                </div>
                <!-- /.col-lg-12 -->
            </div>

<?php
        }
?>

<?php
        if ($Clean['Process'] == 7 && $HasErrors == false && $Clean['SearchBy'] == 2)
        {
?>
            <!-- /.row -->
            <div class="row">
                <div class="col-lg-12">
                    <div class="panel panel-default">
                        <div class="panel-heading">
                            <strong>Total Records Returned: <?php echo count($ClassSubjectsList); ?></strong>
                        </div>
                        <!-- /.panel-heading -->
                        <div class="panel-body">
                            <div>
                                 <div class="row">
                                    <div class="col-lg-6">
                                    </div>
                                    <div class="col-lg-6">
                                        <div class="print-btn-container"><button id="PrintButton" type="submit" class="btn btn-primary">Print</button></div>
                                    </div>
                                     <div class="col-lg-12">
                                        <div class="report-heading-container"><strong>Exam Summary Details By Subjects <?php echo date('d-m-Y h:i A'); ?></strong></div>
                                </div>
                                </div>
<?php
                            if ($HasErrors == true)
                            {
                                echo $NewRecordValidator->DisplayErrorsInTable();
                            }
?>
                                <div class="row" id="RecordTable">
                                    <div class="col-lg-12">
                                        <table width="100%" class="table table-striped table-bordered table-hover" id="DataTableRecords">
                                            <thead>
                                                <tr>
                                                    <th>S. No</th>
                                                    <th>Subject</th>
                                                    <th>Total Students</th>
                                                    <th>Passed Students</th>
                                                    <th>Failed Students</th>
                                            </thead>
                                            <tbody>
<?php
                                    if (is_array($ClassSubjectsList) && count($ClassSubjectsList) > 0)
                                    {
                                        $Counter = 0;
                                        foreach ($ClassSubjectsList as $ClassSubjectID => $ClassSubjectDetails)
                                        {
?>
											<tr>												
                                                <td><?php echo ++$Counter; ?></td>
                                                <td><?php echo $ClassSubjectDetails['Subject']; ?></td>
                                                <td class="alert alert-info text-center"><?php echo count($TotalStudents); ?></td>
                                                <td class="alert alert-success text-center"><?php echo count($TotalStudents) - $SubjectWiseFailStudents[$ClassSubjectID] ; ?></td>
                                                <td class="alert alert-danger text-center"><?php echo $SubjectWiseFailStudents[$ClassSubjectID] ; ?></td>
											</tr>
<?php
                                        }   
                                    }
?>
                                            </tbody>
                                        </table>
                                    </div>
                                </div>
                            </div>
                            <!-- /.table-responsive -->
                        </div>
                        <!-- /.panel-body -->
                    </div>
                    <!-- /.panel -->
                </div>
                <!-- /.col-lg-12 -->
            </div>

<?php
        }
?>

<?php
        if ($Clean['Process'] == 7 && $HasErrors == false && $Clean['SearchBy'] == 3)
        {
?>
            <!-- /.row -->
            <div class="row">
                <div class="col-lg-12">
                    <div class="panel panel-default">
                        <div class="panel-heading">
                            <strong>Total Records Returned: <?php echo count($ClassSubjectsList); ?></strong>
                        </div>
                        <!-- /.panel-heading -->
                        <div class="panel-body">
                            <div>
                                 <div class="row">
                                    <div class="col-lg-6">
                                    </div>
                                    <div class="col-lg-6">
                                        <div class="print-btn-container"><button id="PrintButton" type="submit" class="btn btn-primary">Print</button></div>
                                    </div>
                                     <div class="col-lg-12">
                                        <div class="report-heading-container"><strong>Fail Students Summary By Exam<?php echo date('d-m-Y h:i A'); ?></strong></div>
                                </div>
                                </div>
<?php
                            if ($HasErrors == true)
                            {
                                echo $NewRecordValidator->DisplayErrorsInTable();
                            }
?>
                                <div class="row" id="RecordTable">
                                    <div class="col-lg-12">
                                        <table width="100%" class="table table-striped table-bordered table-hover" id="DataTableRecords">
                                            <thead>
                                                <tr>
                                                    <th>S. No</th>
                                                    <th>Subject</th>
<?php
                                                    foreach ($ExamTypeList as $ExamTypeID => $ExamTypeName)
                                                    {
                                                        echo '<th>'. $ExamTypeName .'</th>';
                                                    }
?>
                                            </thead>
                                            <tbody>
<?php
                                    if (is_array($ClassSubjectsList) && count($ClassSubjectsList) > 0)
                                    {
                                        $Counter = 0;
                                        foreach ($ClassSubjectsList as $ClassSubjectID => $ClassSubjectDetails)
                                        {
?>
											<tr>												
                                                <td><?php echo ++$Counter; ?></td>
                                                <td><?php echo $ClassSubjectDetails['Subject']; ?></td>
<?php
                                            foreach ($ExamTypeList as $ExamTypeID => $ExamTypeName)
                                            {
                                                echo '<td class="text-danger text-center">'. $ExamWiseFailStudents[$ClassSubjectID][$ExamTypeID] .'</td>';
                                            }
?>
											</tr>
<?php
                                        }   
                                    }
?>
                                            </tbody>
                                        </table>
                                    </div>
                                </div>
                            </div>
                            <!-- /.table-responsive -->
                        </div>
                        <!-- /.panel-body -->
                    </div>
                    <!-- /.panel -->
                </div>
                <!-- /.col-lg-12 -->
            </div>

<?php
        }
?>
        </div>
        <!-- /#page-wrapper -->

    </div>
    <!-- /#wrapper -->
<?php
require_once('../footer.php');
?>
<!-- DataTables JavaScript -->
<script src="../vendor/datatables/js/jquery.dataTables.min.js"></script>
<script src="../vendor/datatables-plugins/dataTables.bootstrap.min.js"></script>
<script src="../vendor/datatables-responsive/dataTables.responsive.js"></script>   
<script type="text/javascript">
$(document).ready(function() {
    $("body").on('click', '.delete-record', function()
    {   
        if (!confirm("Are you sure you want to delete this exam?"))
        {
            return false;
        }
    });

    $('#DataTableRecords').DataTable({
        responsive: true,
        bPaginate: false,
        bSort: false,
        searching: false, 
        info: false
    });

    $('#Class').change(function(){

        var ClassID = parseInt($('#Class').val());
        $('#ClassSubject').html('<option value="0">-- Select Subject --</option>');
        
        if (ClassID <= 0)
        {
            $('#ClassSection').html('<option value="0">-- Select Section --</option>');
            return;
        }
        
        $.post("/xhttp_calls/get_sections_by_classs.php", {SelectedClassID:ClassID}, function(data)
        {
            ResultArray = data.split("|*****|");
            
            if (ResultArray[0] == 'error')
            {
                alert (ResultArray[1]);
                return false;
            }
            else
            {
                $('#ClassSection').html('<option value="0">-- Select Section --</option>' + ResultArray[1]);
            }
        });
    });

     $('#ClassSection').change(function(){

        var ClassID = parseInt($('#Class').val());
        $('#ClassSubject').html('<option value="0">-- Select Subject --</option>');
        
        if (ClassID <= 0)
        {
            $('#ClassSection').html('<option value="0">-- Select Section --</option>');
            return;
        }
        
        $.post("/xhttp_calls/get_subjects_by_class.php", {SelectedClassID:ClassID}, function(data)
        {
            ResultArray = data.split("|*****|");
            
            if (ResultArray[0] == 'error')
            {
                alert (ResultArray[1]);
                return false;
            }
            else
            {
                $('#ClassSubject').html('<option value="0">-- Select Subject --</option>' + ResultArray[1]);
            }
        });
    });


});
</script>
<!-- JavaScript To Print A Report -->
<script src="js/print-report.js"></script>
<script src="/admin/js/print-report.js"></script>
</body>
</html>