<?php
require_once("../../../classes/class.users.php");
require_once("../../../classes/class.validation.php");
require_once("../../../classes/class.authentication.php");

require_once('../../../classes/school_administration/class.academic_years.php');
require_once("../../../classes/school_administration/class.students.php");
require_once("../../../classes/school_administration/class.parent_details.php");
require_once("../../../classes/school_administration/class.student_details.php");

require_once("../../../classes/school_administration/class.classes.php");
require_once("../../../classes/school_administration/class.section_master.php");
require_once("../../../classes/school_administration/class.class_sections.php");
require_once('../../../classes/school_administration/class.class_helpers.php');

require_once("../../../classes/class.convert_number_to_words.php");
require_once("../../../classes/class.date_processing.php");
require_once("../../../includes/global_defaults.inc.php");

//1. RECHECK IF THE USER IS VALID //
try
{
    $AuthObject = new ApplicationAuthentication;
    $LoggedUser = new User(0, $AuthObject->CheckValidUser());
}

// THIS CATCH BLOCK BUBBLES THE EXCEPTION TO THE BUILT IN 'Exception' CLASS IF THERE ARE ANY UNCAUGHT ERRORS //
catch (ApplicationAuthException $e)
{
    header('location:/admin/unauthorized_login_admin.php');
    exit;
}
catch (Exception $e)
{
    header('location:/admin/unauthorized_login_admin.php');
    exit;
}
// END OF 1. //

if ($LoggedUser->HasPermissionForTask(TASK_EDIT_STUDENT) !== true)
{
	header('location:/admin/unauthorized_login_admin.php');
	exit;
}

$HasErrors = false;

$AcademicYearID = 0;
$AcademicYearName = '';

$AcademicYearID = AcademicYear::GetCurrentAcademicYear($AcademicYearName);

$SchoolName = 'GRACE MODERN JUNIOR HIGH SCHOOL';
$AffilationDetails = 'RECOGNIZED (ENGLISH MEDIUM)';
$OtherDetails = 'Run Under Christian Community Educational Society, Sitapur';
$Address = '110, AGHA COLONY, CIVIL LINES, SITAPUR, UP';
$Pincode = 261001;
$City = 'SITAPUR';
$State = 'UP';
$ContactNumber = '05862-271663, 9450030012';
$AffilationNumber = '';

$Clean = array();

$Clean['Process'] = 0;

$Clean['Blank'] = '';

$Clean['ClassSectionID'] = 0;
$Clean['ClassID'] = 0;
$Clean['Class'] = '';
$Clean['ClassInWords'] = '';

$Clean['FirstName'] = '';
$Clean['LastName'] = '';

$Clean['DOB'] = '';
$Clean['DOBInWords'] = '';
$Clean['Gender'] = '';

$Clean['Address1'] = '';
$Clean['Address2'] = '';

$Clean['Religion'] = '';
$Clean['Category'] = '';
$Clean['BloodGroup'] = '';
$Clean['AdmissionDate'] = '';
$Clean['AdmissionClass'] = '';

$Clean['FatherFirstName'] = '';
$Clean['FatherLastName'] = '';
$Clean['MotherFirstName'] = '';
$Clean['MotherLastName'] = '';

$Clean['TCNumber'] = '';
$Clean['ResultStatus'] = '';
$Clean['NccCadet'] = '';
$Clean['GeneralConduct'] = 'Satisfactory';
$Clean['LastDateOfSession'] = '';
$Clean['TcIssueDate'] = '';
$Clean['LeavingDate'] = '';
$Clean['ReasonOfLeaving'] = '';
$Clean['OtherRemark'] = '';

$Clean['SelectedStudents'] = '';
$Clean['ClassSectionID'] = 0;
$Clean['Aadhar'] = '';

if (isset($_GET['SelectedStudents']))
{
    $Clean['SelectedStudents'] = (string) $_GET['SelectedStudents'];
}

if ($Clean['SelectedStudents'] == '')
{
    header('location:admin/error.php');
    exit;
}

if (isset($_GET['ClassSectionID']))
{
    $Clean['ClassSectionID'] = (int) $_GET['ClassSectionID'];
}

// if ($Clean['ClassSectionID'] <= 0)
// {
//     header('location:admin/error.php');
//     exit;
// }

$Clean['SelectedStudentList'] = explode(',', $Clean['SelectedStudents']);

require_once('../../html_header.php');
?>
<title>Transfer Certificate</title>
<link href="../../vendor/jquery-ui/jquery-ui.min.css" rel="stylesheet">
  <link rel="stylesheet" href="//code.jquery.com/ui/1.12.1/themes/base/jquery-ui.css">
<style>
    label, input { display:block; }
    input.text { margin-bottom:12px; width:95%; padding: .4em; }
    fieldset { padding:0; border:0; margin-top:25px; }
    h1 { font-size: 1.2em; margin: .6em 0; }
    div#users-contain { width: 350px; margin: 20px 0; }
    div#users-contain table { margin: 1em 0; border-collapse: collapse; width: 100%; }
    div#users-contain table td, div#users-contain table th { border: 1px solid #eee; padding: .6em 10px; text-align: left; }
    .ui-dialog .ui-state-error { padding: .3em; }
    .validateTips { border: 1px solid transparent; padding: 0.3em; }
  </style>
</head>

<body>

    <div id="wrapper">
        <!-- Navigation -->
        <nav class="navbar navbar-default navbar-static-top" role="navigation" style="margin-bottom: 0">
<?php 
            require_once('../../site_header.php');
            require_once('../../left_navigation_menu.php');
?>                    
            <!-- /.navbar-static-side -->
        </nav>

        <div id="page-wrapper">
            <div class="row">
                <div class="col-lg-12">
                    <h1 class="page-header">Transfer Certificate</h1>
                </div>
                <!-- /.col-lg-12 -->
            </div>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <strong>Transfer Certificate</strong>
                </div>
                <div class="panel-body">
                    <div>
                        <div class="row">
                            <div class="col-lg-6">                                     
                            </div>
                            <div class="col-lg-6">
                                <div class="print-btn-container"><button id="PrintButton" type="submit" class="btn btn-primary">Print</button></div>
                            </div>
                        </div>
                        <div class="row" id="RecordTableHeading" style="page-break-before: always;">
<?php

                            foreach ($Clean['SelectedStudentList'] as $key => $StudentID) 
                            {
                                try
                                {
                                    $CurrentStudent = new StudentDetail($StudentID); 
                                    $CurrentParent = new ParentDetail($CurrentStudent->GetParentID()); 
                                    
                                    $CurrentClassSections = new ClassSections($CurrentStudent->GetClassSectionID());
                                    $CurrentClass = new AddedClass($CurrentClassSections->GetClassID());
                                    
                                    $Clean['Aadhar'] = $CurrentStudent->GetAadharNumber();
                                    $Clean['ClassSectionID'] = $CurrentStudent->GetClassSectionID();
                                    $Clean['Class'] = $CurrentClass->GetClassName();
                                    $Clean['ClassID'] = $CurrentClassSections->GetClassID();
                                    
                                    if (is_numeric($Clean['Class']))
                                    {
                                        $Clean['ClassInWords'] = NumberConvert::convertNumber($Clean['Class']);
                                    }
                                    else
                                    {
                                        $Clean['ClassInWords'] = $Clean['Class'];
                                    }
                            
                                    $Clean['FirstName'] = $CurrentStudent->GetFirstName();
                                    $Clean['LastName'] = $CurrentStudent->GetLastName();
                                    $Clean['DOB'] = date('d/m/Y', strtotime($CurrentStudent->GetDOB()));
                                    
                                    // start code fro convert date in to words
                                    
                                    $NewDob = explode('-', $CurrentStudent->GetDOB());
                                    
                                    $Year = $NewDob[0];
                                    $Month = $NewDob[1];
                                    $Day  = $NewDob[2];
                                    
                                    $BirthDay = NumberConvert::convertNumber($Day);
                                    $BirthYear = NumberConvert::convertNumber($Year);
                                    $MonthNumber = $Month;
                                    
                                    $DateObj = DateTime::createFromFormat('!m', $MonthNumber);//Convert the number into month name
                                    $MonthName = $DateObj->format('F');
                                    
                                    $Clean['DOBInWords'] = $BirthDay .' '. $MonthName .' '. $BirthYear;
                                    
                                    // end code fro convert date in to words
                                    
                                    $Clean['Gender'] = $CurrentStudent->GetGender();        
                                    $Clean['EnrollmentID'] = $CurrentStudent->GetEnrollmentID();        
                                    $Clean['Category'] = $CurrentStudent->GetCategory();        
                                    $Clean['BloodGroup'] = $CurrentStudent->GetBloodGroup();        
                                    
                                    if ($Clean['ClassID'] > 8 && $Clean['Gender'] == 'Female')
                                    {
                                        $Clean['NccCadet'] = 'Girl Guide';
                                    }
                                    
                                    $Clean['Address'] = $CurrentStudent->GetAddress1();
                            
                                    if ($Clean['Address'] == '') 
                                    {
                                        $Clean['Address'] = $CurrentStudent->GetAddress2();         
                                    }        
                                    
                                    if ($CurrentStudent->GetAdmissionDate() != '0000-00-00')
                                    {
                                        $Clean['AdmissionDate'] = date('d/m/Y', strtotime($CurrentStudent->GetAdmissionDate()));    
                                    }
                                    
                                    $Clean['AdmissionClass'] = $CurrentStudent->GetLastClass();
                                    $Clean['Religion'] = $CurrentStudent->GetReligion();
                                   
                                    $CurrentParent = new ParentDetail($CurrentStudent->GetParentID());
                            
                                    $Clean['FatherFirstName'] = $CurrentParent->GetFatherFirstName();
                                    $Clean['FatherLastName'] = $CurrentParent->GetFatherLastName();
                                    $Clean['MotherFirstName'] = $CurrentParent->GetMotherFirstName();
                                    $Clean['MotherLastName'] = $CurrentParent->GetMotherLastName();
                                    
                                    $StudentTCDetails = array();
                                    $StudentTCDetails = ClassHelpers::GetStudentTCDetails($StudentID);
                                    
                                    if (count($StudentTCDetails) > 0)
                                    {
                                        $Clean['TCNumber'] = $StudentTCDetails[$StudentID]['TCNumber'];
                                        
                                        $Clean['ResultStatus'] = $StudentTCDetails[$StudentID]['ResultStatus'];
                                        $Clean['NccCadet'] = $StudentTCDetails[$StudentID]['NccCadet'];
                                        $Clean['GeneralConduct'] = $StudentTCDetails[$StudentID]['GeneralConduct'];
                                        
                                        if ($StudentTCDetails[$StudentID]['LastDateOfSession'] != '0000-00-00')
                                        {
                                            $Clean['LastDateOfSession'] = date('d/m/Y', strtotime($StudentTCDetails[$StudentID]['LastDateOfSession']));    
                                        }
                                        
                                        if ($StudentTCDetails[$StudentID]['TcIssueDate'] != '0000-00-00')
                                        {
                                            $Clean['TcIssueDate'] = date('d/m/Y', strtotime($StudentTCDetails[$StudentID]['TcIssueDate']));    
                                        }
                                        
                                        if ($StudentTCDetails[$StudentID]['LeavingDate'] != '0000-00-00')
                                        {
                                            $Clean['LeavingDate'] = date('d/m/Y', strtotime($StudentTCDetails[$StudentID]['LeavingDate']));    
                                        }
                                        
                                        $Clean['ReasonOfLeaving'] = $StudentTCDetails[$StudentID]['ReasonOfLeaving'];
                                        $Clean['OtherRemark'] = $StudentTCDetails[$StudentID]['OtherRemark'];
                                    }
                                }
                                catch (ApplicationDBException $e)
                                {
                                    header('location:admin/error.php');
                                    exit;
                                }
                                catch (Exception $e)
                                {
                                    header('location:admin/error.php');
                                    exit;
                                }
                                
?>
                                <div class="align-center" style="position: relative; width:740px; height:1050px; border:1px solid grey; display:block;">
                                    <div style="height:100px; width:130px; margin-left:10px; float:left; margin-top:5px;">
                                        <img src="../../../site_images/school_logo/school_logo.jpeg" height="80px;" width="130px;" style="margin-left:12px; margin-top:10px;" align="center;">
                                    </div>
                                    
                                    <div style="height:100px; width:550px; float:left; margin-left:10px; margin-top:10px; text-align:center;">
                                        <strong style="font-size:25px;"><?php echo $SchoolName; ?></strong>
                                        <br><strong style="font-size:15px;"><?php echo $Address ; ?></strong>
                                        <br><strong style="font-size:15px;"><?php echo 'PIN CODE- '. $Pincode .' Phone: '. $ContactNumber ; ?></strong>
                                        <br><strong style="font-size:18px;"><?php echo $AffilationDetails; ?></strong>
                                    </div>
                                    
                                    <!--<div style="height:100px; width:130px; margin-right:10px; float:left; margin-top:5px;">-->
                                    <!--    <img src="../../../site_images/school_logo/GMS-LOGO-ADDEd.png" height="80px;" width="90px;" style="margin-left:22px; margin-top:10px;" align="center;">-->
                                    <!--</div>-->
                                    
                                    <center>
                                        <div style="height:25px; width:510px; margin-top:115px; text-align:center; border:1px solid black; display:block; border-radius: 1px;">
                                            <p style=" font-size:16px;"><?php echo $OtherDetails; ?></p>
                                        </div>
                                    </center>
                                    <center>
                                        <div style="height:35px; width:300px; margin-top:14px; text-align:center; border:1px solid black; display:block; border-radius: 5px;">
                                            <p style=" font-size:18px; margin-top: 1px;"><b>TRANSFER CERTIFICATE</b></p>
                                        </div>
                                    </center>
                                    <div style="margin-top: 20px; margin-left: 10px;">
                                        <p style="font-family: normal; margin-top: 20px; display: flex;">Recognition No : <span style="border-bottom: 1px dotted #000; text-decoration: none; width: 100px;  "><b>&nbsp;&nbsp;&nbsp; 08/2016</b></p>
    
                                        <p style="font-family: normal; margin-top: 10px; display: flex;">TC No :<span class="" style="border-bottom: 1px dotted #000; text-decoration: none; width: 150px;" id="TCNumber<?php echo $StudentID;?>"><b>&nbsp;&nbsp;<?php echo $Clean['TCNumber'];?>&nbsp;&nbsp;</b></span> <span style="margin-left: 305px;">Scholar No : </span><span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 130px; "><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['EnrollmentID'] ;?></b></span></p>
                                        
                                        <p style="font-family: normal; margin-top: 10px; display: flex;"><strong style="margin-right: 10px;">1.</strong> Name of the Pupil :<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 555px; margin-left: 15px;" id="StudentName<?php echo $StudentID;?>"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['FirstName'] .' '. $Clean['LastName'];?></b></span></p>
                                        <p style="font-family: normal; margin-top: 10px; display: flex;"><strong style="margin-right: 10px;">2.</strong> Father's/Guardian's Name :<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 510px; margin-left: 15px;"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['FatherFirstName'] .' '. $Clean['FatherLastName'];?></b></span></p>
                                        <p style="font-family: normal; margin-top: 10px; display: flex;"><strong style="margin-right: 10px;">3.</strong> Mother's Name :<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 555px; margin-left: 15px;"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['MotherFirstName'] .' '. $Clean['MotherLastName'];?></b></span></p>
                                        <p style="font-family: normal; margin-top: 10px; display: flex;"><strong style="margin-right: 10px;">4.</strong> Nationality :<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 155px; margin-left: 15px;"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo 'Indian';?></b></span> Religion : <span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 160px; "><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['Religion'] ;?></b></span> Category : <span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 150px; "><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['Category'] ;?></b></span></p>
                                        <p style="font-family: normal; margin-top: 10px; display: flex;"><strong style="margin-right: 10px;">5.</strong> Address :<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 600px; margin-left: 15px;"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['Address'];?></b></span></p>
                                        <p style="font-family: normal; margin-top: 10px; display: flex;"><strong style="margin-right: 10px;">6.</strong> Date of Birth According to Scholar Register :<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 180px; margin-left: 15px;"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['DOB'];?></b></span> Blood Group : <span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 130px; "><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['BloodGroup'] ;?></b></span></p>
                                        <p style="font-family: normal; margin-top: 10px; display: flex;"><strong style="margin-right: 20px;"></strong> (in words) :<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 585px; margin-left: 20px;"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['DOBInWords'] ;?></b></span></p>
                                        <p style="font-family: normal; margin-top: 10px; display: flex;"><strong style="margin-right: 10px;">7.</strong> Date of admission in the school with class :<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 185px; margin-left: 15px;"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['AdmissionDate'];?></b></span> Class : <span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 180px; "><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['AdmissionClass'] ;?></b></span></p>
                                        
                                        <p style="font-family: normal; margin-top: 10px; display: flex;"><strong style="margin-right: 10px;">8.</strong> Class in which pupil last studied (in figure) :<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 155px; margin-left: 15px;"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['Class'];?></b></span> (in words) : <span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 180px; "><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['ClassInWords'] ;?></b></span></p>
                                        <p style="font-family: normal; margin-top: 10px; display: flex;"><strong style="margin-right: 20px;"></strong> *Passed/Promoted to next class (yes/no) :<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 415px; margin-left: 15px;" studentID="<?php echo $StudentID;?>" id="ResultStatus<?php echo $StudentID;?>"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['ResultStatus'];?></b></span></p>
                                        
                                        <p style="font-family: normal; margin-top: 10px; display: flex;"><strong style="margin-right: 10px;">9.</strong> Aadhar Number :<span class="" style="border-bottom: 1px dotted #000; text-decoration: none; width: 385px; margin-left: 15px;" id=""><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['Aadhar'];?></b></span></p>
                                        <p style="font-family: normal; margin-top: 10px; display: flex;"><strong style="margin-right: 10px;">10.</strong> Whether <?php echo ($Clean['ClassID'] > 8) ? 'Girl Guide' : 'NCC Cadet/Boy Scout/Girl Guide' ;?> :<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 385px; margin-left: 15px;" studentID="<?php echo $StudentID;?>" id="NccCadet<?php echo $StudentID;?>"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['NccCadet'];?></b></span></p>
                                        <p style="font-family: normal; margin-top: 10px; display: flex;"><strong style="margin-right: 10px;">11.</strong> General conduct and character :<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 455px; margin-left: 15px;" studentID="<?php echo $StudentID;?>" id="GeneralConduct<?php echo $StudentID;?>"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['GeneralConduct'];?></b></span></p>
                                        <p style="font-family: normal; margin-top: 10px; display: flex;"><strong style="margin-right: 10px;">12.</strong> Last date of session :<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 495px; margin-left: 15px;" studentID="<?php echo $StudentID;?>" id="LastDateOfSession<?php echo $StudentID;?>"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['LastDateOfSession'];?></b></span></p>
                                        <p style="font-family: normal; margin-top: 10px; display: flex;"><strong style="margin-right: 10px;">13.</strong> Date of issue of transfer certificate :<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 465px; margin-left: 15px;" studentID="<?php echo $StudentID;?>" id="TcIssueDate<?php echo $StudentID;?>"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['TcIssueDate'];?></b></span></p>
                                        <p style="font-family: normal; margin-top: 10px; display: flex;"><strong style="margin-right: 10px;">14.</strong> Date of leaving the school :<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 505px; margin-left: 15px;" studentID="<?php echo $StudentID;?>" id="LeavingDate<?php echo $StudentID;?>"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['LeavingDate'];?></b></span></p>
                                        
                                        <p style="font-family: normal; margin-top: 10px; display: flex;"><strong style="margin-right: 10px;">15.</strong> Reason for leaving the school :<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 475px; margin-left: 15px;" studentID="<?php echo $StudentID;?>" id="ReasonOfLeaving<?php echo $StudentID;?>"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['ReasonOfLeaving'];?></b></span></p>
                                        
                                        <p style="font-family: normal; margin-top: 10px; display: flex;"><strong style="margin-right: 20px;"></strong> * Any other remarks :<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 540px; margin-left: 15px;" studentID="<?php echo $StudentID;?>" id="OtherRemark<?php echo $StudentID;?>"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['OtherRemark'];?></b></span></p>
    
                                    </div>
                                    <div style="margin-top: 100px; margin-left: 20px;">
                                        <div style="font-family: normal; font-size:15px; float: left; font-weight: 22px; margin-top: 10px; display: flex; border-top: 1px solid black;"> Prepared & Checked by  </div>
                                        <div style="font-family: normal; font-size:15px; float: right; font-weight: 22px; margin-top: 10px; margin-right: 60px; display: flex; border-top: 1px solid black;">&nbsp;&nbsp;&nbsp;&nbsp;Head Master&nbsp;&nbsp;&nbsp;&nbsp;<br></div>
                                    </div>
                                </div>
                                <div style="page-break-after: always;"></div>
<?php
                            }
?>
                        </div>
                        
                    </div>
                </div>
            </div>
        </div>
        <!-- /#page-wrapper -->

<div id="dialog-form" title="Edit TC Details">
  <p class="validateTips">Please fill other details for TC of <u><b><span id="StudentName"></span></b></u>.</p>
 
  <form>
    <fieldset>
      <label for="ResultStatus">Passed/Promoted to next class </label>
      <input type="text" name="ResultStatus" id="ResultStatus" value="" class="text ui-widget-content ui-corner-all">
      
      <input type="hidden" name="TCNumber" id="TCNumber" value="">
      <input type="hidden" name="StudentID" id="StudentID" value="">
      
      <label for="NccCadet">Ncc Cadet</label>
      <input type="text" name="NccCadet" id="NccCadet" value="" class="text ui-widget-content ui-corner-all">
      
      <label for="GeneralConduct">General Conduct</label>
      <input type="text" name="GeneralConduct" id="GeneralConduct" value="" class="text ui-widget-content ui-corner-all">
      
      <label for="LastDateOfSession">Last Date Of Session</label>
      <input type="text" name="LastDateOfSession" id="LastDateOfSession" value="" class="text ui-widget-content ui-corner-all select-date">
      
      <label for="TcIssueDate">Tc Issue Date</label>
      <input type="text" name="TcIssueDate" id="TcIssueDate" value="" class="text ui-widget-content ui-corner-all select-date">
      
      <label for="LeavingDate">Leaving Date</label>
      <input type="text" name="LeavingDate" id="LeavingDate" value="" class="text ui-widget-content ui-corner-all select-date">
      
      <label for="ReasonOfLeaving">Reason Of Leaving</label>
        <select name="ReasonOfLeaving" id="ReasonOfLeaving" class="ui-widget-content ui-corner-all" style="margin-bottom:12px; width: 95%; height:30px; padding:.4em;">
          <option value="Parent`s wish">Parent`s wish</option>
          <option value="Parent transfered">Parent transfered</option>
          <option value="Last class passed">Last class passed</option>
          <option value="Other">Other</option>
        </select>
        
        <!--<input type="text" name="ReasonOfLeaving" id="ReasonOfLeaving" value="" class="text ui-widget-content ui-corner-all">-->
      
      <label for="OtherRemark">Other Remark</label>
      <input type="text" name="OtherRemark" id="OtherRemark" value="" class="text ui-widget-content ui-corner-all">
      
      <!-- Allow form submission with keyboard without duplicating the dialog button -->
      <input type="submit" tabindex="-1" style="position:absolute; top:-1000px">
    </fieldset>
  </form>
</div>
    </div>
    <!-- /#wrapper -->
<?php
require_once('../../footer.php');
?>
<script src="https://code.jquery.com/ui/1.12.1/jquery-ui.js"></script>
<script src="../../js/print-report.js"></script>
<script type="text/javascript">
$(document).ready(function () {
    $(".select-date").datepicker({
        changeMonth: true,
        changeYear: true,
        dateFormat: 'dd/mm/yy'
    });
    
    $('.unique-function').click(function () {
        
        if ($(this).attr('studentID') )
        {
            var StudentID = $(this).attr('studentID');
            
            $('#StudentID').val(StudentID);
            $('#TCNumber').val($('#TCNumber'+StudentID).text().trim());
            $('#StudentName').text($('#StudentName'+StudentID).text().trim());
            
            $('#ResultStatus').val($('#ResultStatus'+StudentID).text().trim());
            $('#NccCadet').val($('#NccCadet'+StudentID).text().trim());
            $('#GeneralConduct').val($('#GeneralConduct'+StudentID).text().trim());
            $('#LastDateOfSession').val($('#LastDateOfSession'+StudentID).text().trim());
            $('#TcIssueDate').val($('#TcIssueDate'+StudentID).text().trim());
            $('#LeavingDate').val($('#LeavingDate'+StudentID).text().trim());
            $('#ReasonOfLeaving').val($('#ReasonOfLeaving'+StudentID).text().trim());
            $('#OtherRemark').val($('#OtherRemark'+StudentID).text().trim());
            
            dialog.dialog( "open" );
        }
        else
        {
            var DataValue = prompt('Enter Details', $(this).text().trim());
            if (DataValue)
            {
                $(this).html('&nbsp;&nbsp;<b>' + DataValue + '</b>');
            }    
        }
    });
    
    function SaveTcDetails()
    {
        var TCNumber = '';
        var StudentID = '';
        
        var ResultStatus = '';
    	var NccCadet = '';
    	var GeneralConduct = '';
    	var LastDateOfSession = '';
    	var TcIssueDate = '';
    	var LeavingDate = '';
    	var ReasonOfLeaving = '';
    	var OtherRemark = '';

    	TCNumber = $('#TCNumber').val();
    	StudentID = $('#StudentID').val();
    	
    	ResultStatus = $('#ResultStatus').val();
    	NccCadet = $('#NccCadet').val();
    	GeneralConduct = $('#GeneralConduct').val();
    	LastDateOfSession = $('#LastDateOfSession').val();
    	TcIssueDate = $('#TcIssueDate').val();
    	LeavingDate = $('#LeavingDate').val();
    	ReasonOfLeaving = $('#ReasonOfLeaving').val();
    	OtherRemark = $('#OtherRemark').val();
    
    	if (TCNumber == '' || StudentID == '') 
    	{
    		alert('Unknown error, please try again.');
    		return false;
    	}

    	$.post("/xhttp_calls/update_student_tc_details.php", {TCNumber:TCNumber, StudentID:StudentID, ResultStatus:ResultStatus, NccCadet:NccCadet, GeneralConduct:GeneralConduct, LastDateOfSession:LastDateOfSession, TcIssueDate:TcIssueDate, LeavingDate:LeavingDate, ReasonOfLeaving:ReasonOfLeaving, OtherRemark:OtherRemark}, function(data)
        {
            ResultArray = data.split("|*****|");
            
            if (ResultArray[0] == 'error')
            {
                alert (ResultArray[1]);
                return false;
            }
            else
            {	
                $('#ResultStatus'+StudentID).html('&nbsp;&nbsp;<b>' + ResultStatus + '</b>');
                $('#NccCadet'+StudentID).html('&nbsp;&nbsp;<b>' + NccCadet + '</b>');
                $('#GeneralConduct'+StudentID).html('&nbsp;&nbsp;<b>' + GeneralConduct + '</b>');
                $('#LastDateOfSession'+StudentID).html('&nbsp;&nbsp;<b>' + LastDateOfSession + '</b>');
                $('#TcIssueDate'+StudentID).html('&nbsp;&nbsp;<b>' + TcIssueDate + '</b>');
                $('#LeavingDate'+StudentID).html('&nbsp;&nbsp;<b>' + LeavingDate + '</b>');
                $('#ReasonOfLeaving'+StudentID).html('&nbsp;&nbsp;<b>' + ReasonOfLeaving + '</b>');
                $('#OtherRemark'+StudentID).html('&nbsp;&nbsp;<b>' + OtherRemark + '</b>');
                
                dialog.dialog( "close" );
            }
        });
    }
    
    dialog = $( "#dialog-form" ).dialog({
      autoOpen: false,
      height: 600,
      width: 450,
      modal: true,
      position: { my: "right top", at: "right top", of: window },
      buttons: {
        "Save ": SaveTcDetails,
        Cancel: function() {
          dialog.dialog( "close" );
        }
      },
      close: function() {
        form[ 0 ].reset();
      }
    });
    
    form = dialog.find( "form" ).on( "submit", function( event ) {
      event.preventDefault();
      SaveTcDetails();
    });
});
</script>
</body>
</html>