<?php
require_once("../../classes/class.users.php");
require_once('../../classes/class.validation.php');
require_once("../../classes/class.authentication.php");

require_once("../../classes/school_administration/class.academic_years.php");
require_once("../../classes/school_administration/class.classes.php");
require_once("../../classes/school_administration/class.section_master.php");
require_once("../../classes/school_administration/class.class_sections.php");

require_once("../../classes/school_administration/class.students.php");
require_once("../../classes/school_administration/class.student_details.php");

require_once("../../classes/class.ui_helpers.php");
require_once("../../includes/global_defaults.inc.php");

//1. RECHECK IF THE USER IS VALID //
try {
    $AuthObject = new ApplicationAuthentication;
    $LoggedUser = new User(0, $AuthObject->CheckValidUser());
}

// THIS CATCH BLOCK BUBBLES THE EXCEPTION TO THE BUILT IN 'Exception' CLASS IF THERE ARE ANY UNCAUGHT ERRORS //
catch (ApplicationAuthException $e) {
    header('location:../unauthorized_login_admin.php');
    exit;
} catch (Exception $e) {
    header('location:../unauthorized_login_admin.php');
    exit;
}
// END OF 1. //

// if ($LoggedUser->HasPermissionForTask(TASK_ADD_STUDENT) !== true) {
//     header('location:/admin/unauthorized_login_admin.php');
//     exit;
// }

$AllGirlsChildReport = array();
$AllGirlsChildReport = StudentDetail::GirlsChildReport();

require_once('../html_header.php');
?>
<title>Students</title>
<!-- DataTables CSS -->
<link href="../vendor/datatables-plugins/dataTables.bootstrap.css" rel="stylesheet">

<!-- DataTables Responsive CSS -->
<link href="../vendor/datatables-responsive/dataTables.responsive.css" rel="stylesheet">
</head>

<body>

    <div id="wrapper">
        <!-- Navigation -->
        <nav class="navbar navbar-default navbar-static-top" role="navigation" style="margin-bottom: 0">
            <?php
            require_once('../site_header.php');
            require_once('../left_navigation_menu.php');
            ?>
            <!-- /.navbar-static-side -->
        </nav>

        <div id="page-wrapper">
            <div class="row">
                <div class="col-lg-12">
                    <h1 class="page-header">Sibiling's Girls Report</h1>
                </div>
                <!-- /.col-lg-12 -->
            </div>
            <div class="row">
                <div class="col-lg-12">
                    <div class="panel panel-default">
                        <div class="panel-heading">
                            <strong>Total Records Returned: <?php echo count($AllGirlsChildReport); ?></strong>
                        </div>
                        <!-- /.panel-heading -->
                        <div class="panel-body">
                            <div>
                                <div class="row" id="RecordTableHeading">
                                    <div class="col-lg-12">
                                        <div class="report-heading-container"><strong>Girls Child Report on <?php echo date('d-m-Y h:i A'); ?></strong></div>
                                    </div>
                                </div>
                                <div class="row" id="RecordTable">
                                    <div class="col-lg-12">
                                        <table width="100%" class="table table-striped table-bordered table-hover" id="DataTableRecords">
                                            <thead>
                                                <tr>
                                                    <th>S. No</th>
                                                    <th>Parent Name</th>
                                                    <th>Mother Name</th>
                                                    <th class="text-center">Number of Girl Child</th>
                                                </tr>
                                            </thead>
                                            <tbody>
                                                <?php
                                                if (is_array($AllGirlsChildReport) && count($AllGirlsChildReport) > 0) {
                                                    $Counter = 0;
                                                    foreach ($AllGirlsChildReport as $ParentID => $GirlsChildDetails) {
                                                ?>
                                                        <tr>
                                                            <td><?php echo ++$Counter; ?></td>
                                                            <td><?php echo $GirlsChildDetails['FatherFirstName'] . ' ' . $GirlsChildDetails['FatherLastName']; ?></td>
                                                            <td><?php echo $GirlsChildDetails['MotherFirstName'] . ' ' . $GirlsChildDetails['MotherLastName']; ?></td>
                                                            <td class="text-center">
                                                                <strong>
                                                                    <a style="cursor: pointer;" data-parentid="<?php echo $ParentID; ?>" data-toggle="modal" data-target="#sibiling_report">
                                                                        <?php echo $GirlsChildDetails['TotalGirlsChild']; ?>
                                                                    </a>
                                                                </strong>
                                                            </td>
                                                        </tr>
                                                    <?php }
                                                } else { ?>
                                                    <tr>
                                                        <td colspan="7">No Records</td>
                                                    </tr>
                                                <?php } ?>
                                            </tbody>
                                        </table>
                                    </div>
                                </div>
                            </div>
                            <!-- /.table-responsive -->
                        </div>
                        <!-- /.panel-body -->
                    </div>
                    <!-- /.panel -->
                </div>
                <!-- /.col-lg-12 -->
            </div>
        </div>
    </div>
    <!-- /#wrapper -->

    <?php require_once('../footer.php'); ?>
    <!-- JavaScript To Print A Report -->
    <script src="/admin/js/print-report.js"></script>
    <!-- DataTables JavaScript -->
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js"></script>
    <script type="text/javascript">
        $(document).ready(function() {
            $('#sibiling_report').on('hidden.bs.modal', function(event) {
                $('#sibiling_report_content').html('<center><img style="width: 200px; height: 150px;" src="/assets/images/loader.gif" /></center>');
            });

            $('#sibiling_report').on('shown.bs.modal', function(event) {
                var button = $(event.relatedTarget);
                var parentID = button.data('parentid');
                $.ajax({
                    type: 'GET',
                    url: '../../xhttp_calls/get_sibiling_girls_report.php',
                    data: {
                        parentID: parentID
                    },
                    success: function(response) {
                        $('#sibiling_report_content').html(response);
                    }
                });
            });
        });
    </script>
    <div class="modal fade" id="sibiling_report" role="dialog">
        <div class="modal-dialog modal-lg">
            <!-- Modal content-->
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal">&times;</button>
                    <h4 class="modal-title">Sibiling Girls Report</h4>
                </div>
                <div class="modal-body" id="sibiling_report_content">

                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                </div>
            </div>

        </div>
    </div>
</body>

</html>