<?php
require_once("../../classes/class.users.php");
require_once("../../classes/class.validation.php");
require_once("../../classes/class.authentication.php");

require_once('../../classes/school_administration/class.subject_master.php');
require_once("../../classes/school_administration/class.classes.php");

require_once("../../includes/global_defaults.inc.php");

require_once("../../includes/helpers.inc.php");

//1. RECHECK IF THE USER IS VALID //
try
{
	$AuthObject = new ApplicationAuthentication;
	$LoggedUser = new User(0, $AuthObject->CheckValidUser());
}

// THIS CATCH BLOCK BUBBLES THE EXCEPTION TO THE BUILT IN 'Exception' CLASS IF THERE ARE ANY UNCAUGHT ERRORS //
catch (ApplicationAuthException $e)
{
	header('location:../unauthorized_login_admin.php');
	exit;
}
catch (Exception $e)
{
	header('location:../unauthorized_login_admin.php');
	exit;
}
// END OF 1. //

if ($LoggedUser->HasPermissionForTask(TASK_ADD_CLASS_SUBJECT) !== true)
{
	header('location:/admin/unauthorized_login_admin.php');
	exit;
}

$AllClasses = array();
$AllClasses = AddedClass::GetActiveClasses();

$AllMasterSubjects = array();
$AllMasterSubjects = SubjectMaster::GetActiveSubjectMasters();

$HasErrors = false;

$Clean = array();
$Clean['Process'] = 0;

$Clean['ClassID'] = 0;
$Clean['AssignedSubjects'] = array();

if (isset($_POST['hdnProcess']))
{
	$Clean['Process'] = (int) $_POST['hdnProcess'];
}
elseif(isset($_GET['Process']))
{
	$Clean['Process'] = (int) $_GET['Process'];
}
switch ($Clean['Process'])
{
	case 7:
		if (isset($_POST['drdClassID']))
		{
			$Clean['ClassID'] = (int) $_POST['drdClassID'];
		}
		elseif(isset($_GET['ClassID']))
		{
			$Clean['ClassID'] = (int) $_GET['ClassID'];
		}

		$NewRecordValidator = new Validator();

		$NewRecordValidator->ValidateInSelect($Clean['ClassID'], $AllClasses, 'Unknown Error, Please Try Again.');

		if ($NewRecordValidator->HasNotifications())
		{
			$HasErrors = true;
			break;
		}

		$SelectedAddedClass = New AddedClass($Clean['ClassID']);
		$SelectedAddedClass->FillAssignedSubjects();

		$Clean['AssignedSubjects'] = $SelectedAddedClass->GetAssignedSubjects();
		break;		
}

require_once('../html_header.php');
?>
<title>View Class Subjects</title>
<link href="../vendor/jquery-ui/jquery-ui.min.css" rel="stylesheet">
</head>

<body>

    <div id="wrapper">
    	<!-- Navigation -->
        <nav class="navbar navbar-default navbar-static-top" role="navigation" style="margin-bottom: 0">
<?php 
		require_once('../site_header.php');
		require_once('../left_navigation_menu.php');
?>                    
            <!-- /.navbar-static-side -->
        </nav>

        <div id="page-wrapper">
            <div class="row">
                <div class="col-lg-12">
                    <h1 class="page-header">View Class Subjects</h1>
                </div>
                <!-- /.col-lg-12 -->
            </div>
             <form class="form-horizontal" name="SetClassSubjects" action="view_class_subjects.php" method="post">
            	<div class="panel panel-default">
                    <div class="panel-heading">
                       View Class Subjects
                    </div>
                    <div class="panel-body">
<?php
						if ($HasErrors == true)
						{
							echo $NewRecordValidator->DisplayErrors();
						}
?>                    
                    	<div class="form-group">
                            <label for="ClassList" class="col-lg-2 control-label">Class</label>
                            <div class="col-lg-3">
                            	<select class="form-control"  name="drdClassID">
                            		<option  value="0" >Select Class</option>
<?php
									foreach ($AllClasses as $ClassID => $ClassName)
									{
?>
										<option <?php echo ($ClassID == $Clean['ClassID'] ? 'selected="selected"' : ''); ?> value="<?php echo $ClassID; ?>"><?php echo $ClassName;?></option>
<?php
									}

?>
                            	</select>
                            </div>
                        </div> 
                        <div class="form-group">
						    <div class="col-sm-offset-2 col-lg-10">
						    	<input type="hidden" name="hdnProcess" value="7"/>
						        <button type="submit" class="btn btn-primary">View Subjects</button>
						    </div>
						</div>
                    </div>
                </div>
            </form>
<?php
			if($Clean['Process'] == 7 && $HasErrors == false)
			{	
?>
            	<div class="panel panel-default">
                    <div class="panel-heading">
         				Subjects List
                    </div>
                    <div class="panel-body">
<?php
						$Counter = 1;
?>
							<div class="col-lg-12">
                                <table width="100%" class="table table-striped table-bordered table-hover">
                                    <thead>
                                       <tr>
	                                        <th>S. No</th>
                                            <th>Subject Name</th>
                                        </tr>
                                    </thead>
                                    <tbody>
<?php
										foreach ($Clean['AssignedSubjects'] as $ClassSubjectID => $Details) 
										{
?>
										  	<tr>
											  <td><?php echo $Counter++;?></td>
											  <td><?php echo $AllMasterSubjects[$Details['SubjectID']]; ?></td>
										  	</tr>
<?php
										}
?>
									</tbody>
								</table>
<?php								
}
?>					</div>
				</div>
        </div>
        <!-- /#page-wrapper -->
    </div>
    <!-- /#wrapper -->
<?php
require_once('../footer.php');
if (PrintMessage($_GET, $Message))
{
?>
    <script type="text/javascript">
        alert('<?php echo $Message; ?>');
    </script>
<?php
}
?>
</body>
</html>