<?php
require_once('../../classes/class.users.php');
require_once('../../classes/class.validation.php');
require_once('../../classes/class.authentication.php');
require_once('../../classes/class.authentication.php');
require_once('../../classes/class.date_processing.php');

require_once('../../classes/school_administration/class.academic_year_months.php');

require_once('../../classes/school_administration/class.classes.php');
require_once('../../classes/school_administration/class.class_sections.php');
require_once('../../classes/school_administration/class.students.php');
require_once('../../classes/school_administration/class.student_details.php');

require_once('../../classes/school_administration/class.class_helpers.php');
//require_once('../../classes/school_administration/class.student_tc_details.php');
require_once('../../classes/academic_supervision/class.student_diaries.php');
require_once("../../classes/school_administration/class.branch_staff.php");

require_once('../../includes/global_defaults.inc.php');

//1. RECHECK IF THE USER IS VALID //
try
{
	$AuthObject = new ApplicationAuthentication;
	$LoggedUser = new User(0, $AuthObject->CheckValidUser());
}

// THIS CATCH BLOCK BUBBLES THE EXCEPTION TO THE BUILT IN 'Exception' CLASS IF THERE ARE ANY UNCAUGHT ERRORS //
catch (ApplicationAuthException $e)
{
	header('location:../unauthorized_login_admin.php');
	exit;
}
catch (Exception $e)
{
	header('location:../unauthorized_login_admin.php');
	exit;
}
// END OF 1. //

if ($LoggedUser->HasPermissionForTask(TASK_GENERATE_REPORT_CARD) !== true)
{
	header('location:/admin/unauthorized_login_admin.php');
	exit;
}

$AcademicYearMonths =  array();
$AcademicYearMonths =  AcademicYearMonth::GetMonthsByFeePriority();

$ClassList =  array();
$ClassList = AddedClass::GetActiveClasses();



$AllBranchStaffList = array();
$AllBranchStaffList = BranchStaff::GetActiveBranchStaff('Teaching');

$ClassSectionsList = array();

$RecordDeletedSuccessfully = false;
$HasErrors = false;
$SearchErrors = false;

$Clean = array();
$Clean['Process'] = 0;

$Clean['StudentID'] = 0;
$Clean['ClassID'] = 0;
$Clean['ClassSectionID'] = 0;

$Clean['FromDate'] = '';
$Clean['ToDate'] = '';
$Clean['AssignBy'] = 0;
 $Clean['BranchStaffID']=0;

$Clean['StudentIDList'] = array();

$StudentsList = array();
$TCStudentsList = array();

$TotalRecords = 0;

if (isset($_GET['hdnProcess']))
{
	$Clean['Process'] = (int) $_GET['hdnProcess'];
}
else if (isset($_GET['Process']))
{
	$Clean['Process'] = (int) $_GET['Process'];
}
switch ($Clean['Process'])
{
	case 5:
// 		if ($LoggedUser->HasPermissionForTask(TASK_ADD_EDIT_FEE_GROUP) !== true)
//         {
//             header('location:/admin/unauthorized_login_admin.php');
//             exit;
//         }
        
        if (isset($_GET['DiaryID']))
        {
            $Clean['DiaryID'] = (int) $_GET['DiaryID'];           
        }
       
        if ($Clean['DiaryID'] <= 0)
        {
            header('location:../error_page.php');
            exit;
        }                
        
        $StudentDiaryObj = new StudentDiary($Clean['DiaryID']);
        
        if (!$StudentDiaryObj->Remove())
        {
            $SearchValidator = new Validator();
            $SearchValidator->AttachTextError('Error in executing query.');
            $HasErrors = true;
            break;
        }
        
        $RecordDeletedSuccessfully = true;
	break;

    case 7:
        
        if (isset($_GET['drdClass'])) 
        {
            $Clean['ClassID'] = (int) $_GET['drdClass'];
        }

        if (isset($_GET['drdClassSection'])) 
        {
            $Clean['ClassSectionID'] = (int) $_GET['drdClassSection'];
        }
        
        if (isset($_GET['txtFromDate']))
        {
            $Clean['FromDate'] = strip_tags(trim($_GET['txtFromDate']));
        }
        
        if (isset($_GET['txtToDate']))
        {
            $Clean['ToDate'] = strip_tags(trim($_GET['txtToDate']));
        }
       
        
        if (isset($_GET['drdAssignBy']))
        {
            $Clean['AssignBy'] = strip_tags(trim($_GET['drdAssignBy']));
        }

        $NewRecordValidator = new Validator();
        
        if ($Clean['ClassID'] > 0)
        {
            if ($NewRecordValidator->ValidateInSelect($Clean['ClassID'], $ClassList, 'Please select a class.')) 
            {
                $ClassSectionsList = ClassSections::GetClassSections($Clean['ClassID']);
                
                if ($Clean['ClassSectionID'] > 0)
                {
                    $NewRecordValidator->ValidateInSelect($Clean['ClassSectionID'], $ClassSectionsList, 'Please select a section.');   
                }
            }   
        }
        
        if ($Clean['FromDate'] != '')
        {
            $NewRecordValidator->ValidateDate($Clean['FromDate'], 'Please enter valid From date.');
        }
        
        if ($Clean['ToDate'] != '')
        {
            $NewRecordValidator->ValidateDate($Clean['ToDate'], 'Please enter valid To date.');
        }
        
         if ($Clean['AssignBy'] >0)
        {
            $NewRecordValidator->ValidateInSelect($Clean['AssignBy'], $AllBranchStaffList ,'Please select AssignBy.');
        }
        
        
        
        if ($NewRecordValidator->HasNotifications())
        {
            $HasErrors = true;
            break;
        }
        
        $Filters['ClassID'] = $Clean['ClassID'];
        $Filters['ClassSectionID'] = $Clean['ClassSectionID'];
        
        if ($Clean['FromDate'] != '') 
        {
            $Filters['FromDate'] = date('Y-m-d', strtotime(DateProcessing::ToggleDateDayAndMonth(($Clean['FromDate']))));
        }
        
        if ($Clean['ToDate'] != '') 
        {
            $Filters['ToDate'] = date('Y-m-d', strtotime(DateProcessing::ToggleDateDayAndMonth(($Clean['ToDate']))));
        }
        
        if ($Clean['AssignBy'] != '') 
        {
            $Filters['AssignBy'] = $Clean['AssignBy'];
        }
        
        
        StudentDiary::SearchStudentDiaries($TotalRecords, true, $Filters);
        
        $TCStudentsList = StudentDiary::SearchStudentDiaries($TotalRecords, false, $Filters, 0, $TotalRecords);
        
        // $StudentsList = StudentDetail::GetStudentsByClassSectionID($Clean['ClassSectionID'], 'Active');
        
    break;
}

require_once('../html_header.php');
?>
<title>View e-Diaries</title>
<link href="../vendor/jquery-ui/jquery-ui.min.css" rel="stylesheet">
</head>

<body>

    <div id="wrapper">
    	<!-- Navigation -->
        <nav class="navbar navbar-default navbar-static-top" role="navigation" style="margin-bottom: 0">
<?php 
			require_once('../site_header.php');
			require_once('../left_navigation_menu.php');
?>                    
            <!-- /.navbar-static-side -->
        </nav>

        <div id="page-wrapper">
            <div class="row">
                <div class="col-lg-12">
                    <h1 class="page-header">View e-Diaries</h1>
                </div>
                <!-- /.col-lg-12 -->
            </div>
             <form class="form-horizontal" name="ViewEDiaries" action="view_ediaries.php" method="get">
            	<div class="panel panel-default">
                    <div class="panel-heading">
                        Enter Details
                    </div>
                    <div class="panel-body">
<?php
						if ($HasErrors == true)
						{
							echo $NewRecordValidator->DisplayErrorsInTable();
						}
						else if ($RecordDeletedSuccessfully == true)
                        {
                            echo '<div class="alert alert-danger">Record deleted successfully.</div>';
                        }
?>                    
						<br>
                        <div class="form-group">
                            <label for="Class" class="col-lg-2 control-label">Class</label>
                            <div class="col-lg-3">
                                <select class="form-control"  name="drdClass" id="Class">
                                    <option  value="0" >-- Select Class --</option>
<?php
                                    if (is_array($ClassList) && count($ClassList) > 0)
                                    {
                                        foreach ($ClassList as $ClassID => $ClassName)
                                        {
?>
                                            <option <?php echo ($ClassID == $Clean['ClassID'] ? 'selected="selected"' : ''); ?> value="<?php echo $ClassID; ?>"><?php echo $ClassName; ?></option>
<?php
                                        }
                                    }
?>
                                </select>
                            </div>
                            <label for="Class" class="col-lg-2 control-label">Section</label>
                            <div class="col-lg-3">
                                <select class="form-control" name="drdClassSection" id="ClassSection">
                                    <option value="0">-- Select Section --</option>
<?php
                                if (is_array($ClassSectionsList) && count($ClassSectionsList) > 0)
                                {
                                    foreach ($ClassSectionsList as $ClassSectionID => $SectionName) 
                                    {
                                        echo '<option '.($Clean['ClassSectionID'] == $ClassSectionID ? 'selected="selected"' : '') .' value="'. $ClassSectionID .'">'. $SectionName .'</option>';
                                    }
                                }
?>
                                </select>
                            </div>
                        </div>
                        <div class="form-group">                            
                           
                            <label for="AssignBy" class="col-lg-2 control-label">Assign By</label>
                            <div class="col-lg-3">
                                <select class="form-control" name="drdAssignBy" id="AssignBy">
                                    <option value="">-- Select --</option>
                               <?php     foreach ($AllBranchStaffList as $BranchStaffID => $BranchStaffName)
                                {
?>
                                    <option <?php echo ($BranchStaffID == $Clean['BranchStaffID'] ? 'selected="selected"' : ''); ?> value="<?php echo $BranchStaffID; ?>"><?php echo $BranchStaffName['FirstName'] . " ". $BranchStaffName['LastName']; ?></option>
<?php
                                }
?>
                                </select>
                            </div>
                        </div>
                        
                        <div class="form-group">
                        <div class="col-sm-offset-2 col-lg-10">
                        	<input type="hidden" name="hdnProcess" value="7" />
							<button type="submit" class="btn btn-primary"><i class="fa fa-search"></i>&nbsp;Search</button>
                        </div>
                      </div>
                    </div>
                </div>
            </form>

<?php
        if ($Clean['Process'] == 7 && $HasErrors == false)
        {
?>
            <!-- /.row -->
            <div class="row">
                <div class="col-lg-12">
                    <div class="panel panel-default">
                        <div class="panel-heading">
                            <strong>Total Records Returned: <?php echo $TotalRecords; ?></strong>
                        </div>
                        <div class="panel-body">
                            <div>
<?php
                            if ($SearchErrors == true)
                            {
                                echo $NewRecordValidator->DisplayErrorsInTable();
                            }
?>
                                <div class="row" id="RecordTable">
                                    <div class="col-lg-12">
                                        <table width="100%" class="table table-striped table-bordered table-hover" id="DataTableRecords">
                                            <thead>
                                                <tr>
                                                    <th>S. No</th>
                                                    <th>Heading</th>
                                                    <th>Details</th>
                                                    <th>Class Section</th>
                                                    <th>Assigned By</th>
                                                    <th class="text-center">Created Date</th>
                                                    <th class="text-center">Action</th
                                                </tr>
                                            </thead>
                                            <tbody>
<?php
                                    if (is_array($TCStudentsList) && count($TCStudentsList) > 0)
                                    {
                                        $Counter = 0;
                                        foreach ($TCStudentsList as $StudentTcDetailID => $TCDetails)
                                        {
										/*	echo '<pre>';
											print_R($TCStudentsList);
											exit; */
?>
                                            <tr>
                                                <td><?php echo ++$Counter; ?></td>
                                                <td><?php echo $TCDetails['Heading']; ?></td>
                                                <td><?php echo $TCDetails['Details']; ?></td>
                                                <td><?php echo $TCDetails['ClassName'] .' '. $TCDetails['SectionName']; ?></td>
                                                <td><?php echo $TCDetails['AssignedUserName']; ?></td>
                                                
                                                <td><?php echo $TCDetails['CreateDate']; ?></td>
                                                
                                                <td class="text-center">
                                                    <a href="edit_student_diary.php?Process=2&amp;DiaryID=<?php echo $StudentTcDetailID; ?>">Edit</a>
                                                    <a href="view_ediaries.php?Process=5&amp;DiaryID=<?php echo $StudentTcDetailID; ?>">Delete</a>
                                                </td
                                            </tr>
<?php
                                        }
                                    }
?>
                                            </tbody>
                                        </table>
                                    </div>
                                </div>
                            </div>
                            <!-- /.table-responsive -->
                        </div>
                        <!-- /.panel-body -->
                    </div>
                    <!-- /.panel -->
                </div>
                <!-- /.col-lg-12 -->
            </div>
<?php
        }
?>
        </div>
        <!-- /#page-wrapper -->

    </div>
    <!-- /#wrapper -->
<?php
require_once('../footer.php');
?>
<script src="../vendor/jquery-ui/jquery-ui.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/fancybox/3.5.2/jquery.fancybox.min.js"></script>
<script type="text/javascript">
$(document).ready(function()
{   
    $(".select-date").datepicker({
        changeMonth: true,
        changeYear: true,
        dateFormat: 'dd/mm/yy'
    });
    
	$('#Class').change(function()
    {
        var ClassID = parseInt($('#Class').val());
        
        if (ClassID <= 0)
        {
            $('#ClassSection').html('<option value="0">-- Select Section --</option>');
            return;
        }
        
        $.post("/xhttp_calls/get_sections_by_classs.php", {SelectedClassID:ClassID}, function(data)
        {
            ResultArray = data.split("|*****|");
            
            if (ResultArray[0] == 'error')
            {
                alert (ResultArray[1]);
                return false;
            }
            else
            {
                $('#ClassSection').html('<option value="0">-- Select Section --</option>' + ResultArray[1]);
            }
        });
    });

    $('#ClassSection').change(function()
    {
        var ClassSectionID = parseInt($('#ClassSection').val());
        
        if (ClassSectionID <= 0)
        {
            $('#ClassSection').html('<option value="0">-- Select Section --</option>');
            return;
        }
        
        $.post("/xhttp_calls/get_exams_by_classs_section.php", {SelectedClassSectionID:ClassSectionID}, function(data)
        {
            ResultArray = data.split("|*****|");
            
            if (ResultArray[0] == 'error')
            {
                alert (ResultArray[1]);
                return false;
            }
            else
            {
                $('#ExamList').html(ResultArray[1]);
            }
        });
    });

    $('#AllStudent').change(function(){
        if ($(this).prop("checked") == true)
        {
            $('.check-all-student').prop('checked',true);
        }
        else
        {
            $('.check-all-student').prop('checked',false);
        }
    });

    $('.check-all-student').change(function(){

        if ($(this).attr('anyDue') == 1 && $(this).prop("checked") == true)
        {
            if (!confirm('Are you really want to generate TC with out No-Dues.'))
            {
                $(this).prop('checked', false);
                return false;
            }
            else
            {
                var TotalStudent = <?php echo count($StudentsList);?>;
        
                if ($('input.check-all-student:checked').length == TotalStudent)
                {
                    $('#AllStudent').prop('checked', true);
                }
                else
                {
                    $('#AllStudent').prop('checked', false);
                }       
            }
        }
        else
        {
            var TotalStudent = <?php echo count($StudentsList);?>;
        
            if ($('input.check-all-student:checked').length == TotalStudent)
            {
                $('#AllStudent').prop('checked', true);
            }
            else
            {
                $('#AllStudent').prop('checked', false);
            }
        }
    });
});
</script>
</body>
</html>