<?php
require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/class.db_connect.php');
error_reporting(E_ALL);

class EDiaries
{
	// CLASS MEMBERS ARE DEFINED HERE	//
	private $LastErrorCode;
	private $DBObject; // VARIABLE TO HOLD THE DB CONNECTION //
	
	private $StudentTcDetailID;
	private $StudentID;

	private $TcNumber;
	private $RegistrationNo;

	private $LastClassExamResult;
	private $PromotedToHigherClass;
	private $IsAnyconsession;
	private $NumberOfPTM;

	private $PaidAllDues;
	private $TotalPresentDays;

	private $ResultStatus;
	private $NccCadet;
	private $GeneralConduct;

	private $LastDateOfSession;
	private $TcIssueDate;
	private $SchoolLeavingDate;

	private $ReasonOfLeaving;
	private $Studentisfailed;
	private $SubjectOffered;
	private $OtherRemark;

	private $CreateUserID;
	private $CreateDate;

	private $StudentIDList = array();

	// PUBLIC METHODS START HERE	//
	public function __construct($StudentTcDetailID = 0)
	{
		$this->DBObject = new DBConnect;
		$this->LastErrorCode = 0;
		
		if($StudentTcDetailID != 0)
		{
			$this->StudentTcDetailID = $StudentTcDetailID;
			// SET THE VALUES FROM THE DATABASE.
			$this->GetStudentTcDetailByID();
		}
		else
		{
			
		}
	}
	
	public function Remove()
    {
        try
        {
            $this->RemoveStudentTcDetail();
            return true;
        }
        catch (ApplicationDBException $e)
        {
            $this->LastErrorCode = $e->getCode();
            return false;
        }
        catch (ApplicationARException $e)
        {
            $this->LastErrorCode = $e->getCode();
            return false;
        }
        catch (Exception $e)
        {
            $this->LastErrorCode = APP_ERROR_UNDEFINED_ERROR;
            return false;
        }
    }
	
	// END OF PUBLIC METHODS	//
	
	// START OF STATIC METHODS	//
	
	static function SearchDiariesDetails(&$TotalRecords = 0, $GetTotalsOnly = false, $Filters = array(), $Start = 0, $Limit = 100)
	{
		$DairiesList = array();
		try
		{
			$DBConnObject = new DBConnect();

			$Conditions = array();
			
			if (count($Filters) > 0)
			{
			    if (!empty($Filters['ClassID']))
				{
					$Conditions[] = 'ac.classID = '. $DBConnObject->RealEscapeVariable($Filters['ClassID']);
				}

				if (!empty($Filters['ClassSectionID']))
				{
					$Conditions[] = 'acs.classSectionID = '. $DBConnObject->RealEscapeVariable($Filters['ClassSectionID']);
				}
				
				
				
				if ((!empty($Filters['ToDate'])) && (!empty($Filters['FromDate'])))
				{
					$Conditions[] = "ed.createDate BETWEEN  '".$Filters['FromDate']."' AND '".$Filters['ToDate']."' ";
				}
				
				
				if (!empty($Filters['AssignBy']))
				{
					$Conditions[] = 'asbs.branchStaffID = '. $DBConnObject->RealEscapeVariable($Filters['AssignBy']);
				}
			}
			
			$QueryString = '';

			if (count($Conditions) > 0)
			{
				$QueryString = implode(') AND (', $Conditions);
				
				$QueryString = ' WHERE (' . $QueryString . ')';
			}
			if ($GetTotalsOnly)
			{
				$RSTotal = $DBConnObject->Prepare('SELECT COUNT(Distinct ed.studentDiaryID) AS totalRecords 
													FROM aas_student_diaries ed
													INNER JOIN asa_class_sections acs ON acs.classSectionID = ed.classSectionID 
                                                    INNER JOIN asa_classes ac ON ac.classID = acs.classID 													INNER JOIN asa_section_master asm ON asm.sectionMasterID = acs.sectionMasterID 
													INNER JOIN users u ON ed.createUserID = u.userID
													INNER JOIN asa_branch_staff asbs on asbs.userName = u.userName
                                                  '. $QueryString .';');
				$RSTotal->Execute();
				
				$TotalRecords = $RSTotal->FetchRow()->totalRecords;
				return;
			}
			
			$RSSearch = $DBConnObject->Prepare('SELECT *
													FROM aas_student_diaries ed
													INNER JOIN asa_class_sections acs ON acs.classSectionID = ed.classSectionID 
                                                    INNER JOIN asa_classes ac ON ac.classID = acs.classID 
                                                    INNER JOIN asa_section_master asm ON asm.sectionMasterID = acs.sectionMasterID 
													INNER JOIN users u ON ed.createUserID = u.userID
													INNER JOIN asa_branch_staff asbs on asbs.userName = u.userName
												'. $QueryString .'
												ORDER BY ed.createDate LIMIT ' . (int) $Start . ', ' . (int) $Limit . ';');
			$RSSearch->Execute();
			
			if ($RSSearch->Result->num_rows <= 0)
			{
				return $DairiesList; 
			}
			
			while($SearchRow = $RSSearch->FetchRow())
			{
			   // echo '<pre>';
			   // print_R($SearchRow);
			    
			    $DairiesList[$SearchRow->studentDiaryID]['heading'] = $SearchRow->heading;
				$DairiesList[$SearchRow->studentDiaryID]['details'] = $SearchRow->details;

				$DairiesList[$SearchRow->studentDiaryID]['ClassName'] = $SearchRow->className;
				$DairiesList[$SearchRow->studentDiaryID]['SectionName'] = $SearchRow->sectionName;
				
				$DairiesList[$SearchRow->studentDiaryID]['AssignedUserName'] = $SearchRow->firstName .' '.  $SearchRow->lastName;
				$DairiesList[$SearchRow->studentDiaryID]['CreateDate'] = $SearchRow->createDate;
			}
			
			return $DairiesList;	
		}
		catch (ApplicationDBException $e)
		{
			error_log('DEBUG: ApplicationDBException at EDiaries::SearchDiariesDetails(). Stack Trace: ' . $e->getTraceAsString());
			return $DairiesList;
		}
		catch (Exception $e)
		{
			error_log('DEBUG: Exception at EDiaries::SearchDiariesDetails(). Stack Trace: ' . $e->getTraceAsString());
			return $DairiesList;
		}
	}
	
	static function DeleteHomeWorkDaries($StudentID)
	{		
		try
		{
			$DBConnObject = new DBConnect();
			
		    $RSDeleteTC = $DBConnObject->Prepare('DELETE FROM asa_student_tc_details WHERE studentID = :|1;');
	        $RSDeleteTC->Execute($StudentID);
	        
	        $RSUpdateStudent = $DBConnObject->Prepare('UPDATE asa_students
														SET	status = :|1
														WHERE studentID = :|2 LIMIT 1;');
												
			$RSUpdateStudent->Execute('Active', $StudentID);
			
			return true;
		}
		catch (ApplicationDBException $e)
		{			error_log('DEBUG: ApplicationDBException at EDiaries::DeleteStudentTC(). Stack Trace: ' . $e->getTraceAsString());
			return false;
		}
		catch (Exception $e)
		{
			error_log('DEBUG: Exception at EDiaries::DeleteStudentTC(). Stack Trace: ' . $e->getTraceAsString());
			return false;
		}		
	}}
?>