<?php
require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/class.db_connect.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/school_administration/class.student_details.php');
error_reporting(E_ALL);

class AppStudentDetail extends StudentDetail
{
	// CLASS MEMBERS ARE DEFINED HERE	//
	protected $StudentID;
	protected $StudentPhoto;
	
	// PUBLIC METHODS START HERE	//
	public function __construct($StudentID)
	{
		$this->DBObject = new DBConnect;
		$this->LastErrorCode = 0;
		
		$this->StudentID = $StudentID;
		// SET THE VALUES FROM THE DATABASE.
		parent::__construct($this->StudentID);
	}

	// GETTER AND SETTER FUNCTIONS START HERE	//
	public function GetStudentID()
	{
		return $this->StudentID;
	}
	
	public function GetStudentPhoto()
	{
		return $this->StudentPhoto;
	}
	//  END OF GETTER AND SETTER FUNCTIONS 	//


	public function SaveStudentPhoto($StudentPhoto)
	{
		try
		{
			$RSSave = $this->DBObject->Prepare('UPDATE asa_student_details SET studentPhoto = :|1 WHERE studentID = :|2 LIMIT 1;');
			$RSSave->Execute($StudentPhoto, $this->StudentID);
			return true;
		}

		catch (ApplicationDBException $e)
        {
            error_log('DEBUG: ApplicationDBException at AppStudentDetail::SaveStudentPhoto(). Stack Trace: ' . $e->getTraceAsString());
            return false;
        }
        catch (Exception $e)
        {
            error_log('DEBUG: Exception at AppStudentDetail::SaveStudentPhoto(). Stack Trace: ' . $e->getTraceAsString());
            return false;
        }
	}
	
	public function GetStudentDetails()
	{
		$StudentDetails = array();

		try
        {
	        $RSSearch = $this->DBObject->Prepare('SELECT aas.classSectionID, aas.rollNumber, asd.firstName, asd.lastName, asd.address1, asd.studentPhoto, asd.dob,
	                                                ac.classID, ac.className, ac.classSymbol, asm.sectionName, apd.fatherMobileNumber, apd.fatherEmail, aas.academicYearID
												  FROM asa_students aas
												  INNER JOIN asa_parent_details apd ON apd.parentID = aas.parentID 
												  INNER JOIN asa_student_details asd ON asd.studentID = aas.studentID 
												  
												  INNER JOIN asa_class_sections acs ON acs.classSectionID = aas.classSectionID
												  INNER JOIN asa_classes ac ON ac.classID = acs.classID 
												  INNER JOIN asa_section_master asm ON asm.sectionMasterID = acs.sectionMasterID 
												  
												  WHERE aas.studentID = :|1;');

            $RSSearch->Execute($this->StudentID);

            if ($RSSearch->Result->num_rows <= 0)
            {
                return $StudentDetails;
            }

			while ($SearchStudentDetailsRow = $RSSearch->FetchRow())
			{
				$StudentDetails[$SearchStudentDetailsRow->studentID]['FirstName'] = $SearchStudentDetailsRow->firstName;
				$StudentDetails[$SearchStudentDetailsRow->studentID]['LastName'] = $SearchStudentDetailsRow->lastName;
				$StudentDetails[$SearchStudentDetailsRow->studentID]['StudentPhoto'] = $SearchStudentDetailsRow->studentID . '/' . $SearchStudentDetailsRow->studentPhoto;
				
				$StudentDetails[$SearchStudentDetailsRow->studentID]['RollNumber'] = $SearchStudentDetailsRow->rollNumber;
				$StudentDetails[$SearchStudentDetailsRow->studentID]['ClassName'] = $SearchStudentDetailsRow->className;
				$StudentDetails[$SearchStudentDetailsRow->studentID]['ClassSymbol'] = $SearchStudentDetailsRow->classSymbol;
				$StudentDetails[$SearchStudentDetailsRow->studentID]['SectionName'] = $SearchStudentDetailsRow->sectionName;

				$StudentDetails[$SearchStudentDetailsRow->studentID]['ClassID'] = $SearchStudentDetailsRow->classID;
				$StudentDetails[$SearchStudentDetailsRow->studentID]['ClassSectionID'] = $SearchStudentDetailsRow->classSectionID;
				
				$StudentDetails[$SearchStudentDetailsRow->studentID]['DOB'] = date('d/m/Y', strtotime($SearchStudentDetailsRow->dob));
				
				$StudentDetails[$SearchStudentDetailsRow->studentID]['Address'] = $SearchStudentDetailsRow->address1;
				
				$StudentDetails[$SearchStudentDetailsRow->studentID]['FatherMobileNumber'] = $SearchStudentDetailsRow->fatherMobileNumber;
				$StudentDetails[$SearchStudentDetailsRow->studentID]['FatherEmail'] = $SearchStudentDetailsRow->fatherEmail;
				$StudentDetails[$SearchStudentDetailsRow->studentID]['AcademicYearID'] = $SearchStudentDetailsRow->academicYearID;
			}

            return $StudentDetails;
        }
        catch (ApplicationDBException $e)
        {
            error_log('DEBUG: ApplicationDBException at AppStudentDetail::GetStudentDetails(). Stack Trace: ' . $e->getTraceAsString());
            return $StudentDetails;
        }
        catch (Exception $e)
        {
            error_log('DEBUG: Exception at AppStudentDetail::GetStudentDetails(). Stack Trace: ' . $e->getTraceAsString());
            return $StudentDetails;
        }
	}
	// END OF PUBLIC METHODS	//
	
	// START OF STATIC METHODS	//
	
	// END OF STATIC METHODS	//
	
	// START OF PRIVATE METHODS	//
	
}
?>