<?php
error_log('save_fee_transaction');
error_log(json_encode($_REQUEST));

header("Content-Type:application/json");

require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/class.users.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/class.validation.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/class.authentication.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/class.date_processing.php');

require_once($_SERVER['DOCUMENT_ROOT'] . '/includes/global_defaults.inc.php');

require_once($_SERVER['DOCUMENT_ROOT'] . '/mobile_app_services/classes/class.json_response.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/mobile_app_services/includes/global_defaults.php');

require_once($_SERVER['DOCUMENT_ROOT'] . '/mobile_app_services/includes/process_errors.php');

//Other Required Classess
require_once($_SERVER['DOCUMENT_ROOT'] . '/mobile_app_services/classes/class.api_helpers.php');

require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/fee_management/class.fee_collection.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/school_administration/class.parent_details.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/mobile_app_services/classes/class.app.parent_details.php');

$Response = new JSONResponse();

$Clean = array();
$Filters = array();

$Clean['Token'] = '';

//	Other Variables
$Clean['StudentID'] = '';

$Clean['StudentFeetructureID'] = array();
$Clean['DueAmount'] = array();

$Clean['TempTransactionDetails'] = array();

if (isset($_REQUEST['Token']))
{
	$Clean['Token'] = strip_tags(trim((string) $_REQUEST['Token']));
}

if (isset($_REQUEST['StudentID']))
{
	$Clean['StudentID'] = (int) $_REQUEST['StudentID'];
}   

if (isset($_REQUEST['StudentFeetructureID']))
{
    $Clean['StudentFeetructureID'] = json_decode($_REQUEST['StudentFeetructureID']);
}

if (isset($_REQUEST['DueAmount']))
{
    $Clean['DueAmount'] = json_decode($_REQUEST['DueAmount']);
}

try
{
	$LoggedInParent = new AppParentDetail($Clean['Token']);
    
    if (!array_key_exists($Clean['StudentID'], $LoggedInParent->GetApplicableStudents())) 
	{
		$Response->SetError(1);
		$Response->SetErrorCode(UNKNOWN_ERROR);
		$Response->SetMessage(ProcessAppErrors(UNKNOWN_ERROR));

		echo json_encode($Response->GetResponseAsArray());
		exit;
	}
	
	$StudentFeeStructureIDList = array();
	$StudentDiscountList = array();
	$DueAmountList = array();
	$TransactionPending = array();
	
	$FeeDetails = array();
	$FeeDetails = $LoggedInParent->GetStudentFeeDetails($Clean['StudentID']);
	
	$Counter = 0;
	foreach ($FeeDetails as $Month => $Details) 
	{
	    $DiscountValue = array_column($Details, 'DiscountValue');
	    $DueAmount = array_column($Details, 'DueAmount');
	    $TransactionPending = array_column($Details, 'TransactionPending');
	    
	    foreach (array_column($Details, 'StudentFeeStructureID') as $key => $StudentFeeStructureID)
	    {
	        $StudentFeeStructureIDList[$StudentFeeStructureID] = $StudentFeeStructureID;
	        $StudentDiscountList[$StudentFeeStructureID] = $DiscountValue[$key];
	        $DueAmountList[$StudentFeeStructureID] = $DueAmount[$key];
	        $TransactionPendingList[$StudentFeeStructureID] = $TransactionPending[$key];
	    }
	}
    
	if (count($Clean['StudentFeetructureID']) != count($Clean['DueAmount']))
	{
		$Response->SetError(1);
		$Response->SetErrorCode(UNKNOWN_ERROR);
		$Response->SetMessage(ProcessAppErrors(UNKNOWN_ERROR));	

		echo json_encode($Response->GetResponseAsArray());
		exit;
	}
	
	$TotalDiscount = 0;
	$StudentAmountPaid = 0;
	$StudentAmountPayable = 0;
	
	foreach ($Clean['StudentFeetructureID'] as $Key => $StudentFeeStructureID) 
	{
	    if (!array_key_exists($StudentFeeStructureID, $StudentFeeStructureIDList))
        {
            $Response->SetError(1);
            $Response->SetErrorCode(UNKNOWN_ERROR);
            $Response->SetMessage(ProcessAppErrors(UNKNOWN_ERROR));

            echo json_encode($Response->GetResponseAsArray());
            exit;
        }
        
        if (array_key_exists($StudentFeeStructureID, $TransactionPendingList) && $TransactionPendingList[$StudentFeeStructureID] > 0)
        {
            $Response->SetError(1);
            $Response->SetErrorCode(UNKNOWN_ERROR);
            $Response->SetMessage('Some fees is processing and status is pending. Please wait for some time. Thank You.');

            echo json_encode($Response->GetResponseAsArray());
            exit;
        }
        
        $FeeHeadPayableAmount = 0;
        
        if (array_key_exists($Key, $Clean['DueAmount']))
        {
            $FeeHeadPayableAmount = $Clean['DueAmount'][$Key];   
            
            $Clean['TempTransactionDetails'][$StudentFeeStructureID] = $FeeHeadPayableAmount;
        }
        
		$StudentAmountPayable += $FeeHeadPayableAmount;
		$StudentAmountPaid += $FeeHeadPayableAmount;
		
		$TotalDiscount += $StudentDiscountList[$StudentFeeStructureID];
	}
	
	if (array_sum($Clean['DueAmount']) != $StudentAmountPaid)
    {
        $Response->SetError(1);
        $Response->SetErrorCode(UNKNOWN_ERROR);
        $Response->SetMessage('Invalid amount, please try again.');

        echo json_encode($Response->GetResponseAsArray());
        exit;
    }
        
    $TransactionDetails = array();
    $SchoolFeeTransactionID = 0;

    $TransactionDetails['SchoolBranchID'] = SCHOOL_BRANCH_ID;
    $TransactionDetails['MerchantKey'] = 'IZX1FBDX7U';
    $TransactionDetails['Salt'] = 'HO2JPQ7ZX2';
    $TransactionDetails['StudentID'] = $Clean['StudentID'];
    $TransactionDetails['TransactionID'] = 0;
    $TransactionDetails['Amount'] = $StudentAmountPaid;
    $TransactionDetails['PaymentStatus'] = 'Pending';                           
    $TransactionDetails['CreateUserID'] = $LoggedInParent->GetUserID();
    $TransactionDetails['TempTransactionDetails'] = $Clean['TempTransactionDetails'];

	if (!APIHelpers::SaveFeeTransaction($TransactionDetails, $SchoolFeeTransactionID)) 
	{
		$Response->SetError(1);
		$Response->SetErrorCode(UNKNOWN_ERROR);
		$Response->SetMessage(ProcessAppErrors(UNKNOWN_ERROR));	

		echo json_encode($Response->GetResponseAsArray());
		exit;
	}	
    
    $StudentData = $LoggedInParent->GetApplicableStudents()[$Clean['StudentID']];
    
    $TransactionData = array();

    $TransactionData['CentralFeeTransactionID'] = $SchoolFeeTransactionID;      
    $TransactionData['txnid'] = $SchoolFeeTransactionID;        
    $TransactionData['amount'] = $StudentAmountPaid;
    $TransactionData['productinfo'] = 'test';
    $TransactionData['firstname'] = $StudentData['FirstName'];
    $TransactionData['email'] = $StudentData['FatherEmail'] ? $StudentData['FatherEmail'] : 'managineers@gmail.com';
    $TransactionData['phone'] = $StudentData['FatherMobileNumber'] ? $StudentData['FatherMobileNumber'] : '1234567890';
    $TransactionData['key'] = 'IZX1FBDX7U';
    $TransactionData['Salt'] = 'HO2JPQ7ZX2';
    
    $TransactionData['udf1'] = $Clean['Token'];
    $TransactionData['udf2'] = $Clean['StudentID'];
    $TransactionData['udf3'] = implode(',', $Clean['StudentFeetructureID']);
    $TransactionData['udf4'] = implode(',', $Clean['DueAmount']);
    $TransactionData['udf5'] = '';
    
    $TransactionData['address1'] = 'Lucknow';
    $TransactionData['city'] = 'Lucknow';
    $TransactionData['state'] = 'UP';
    $TransactionData['country'] = 'India';
    $TransactionData['zipcode'] = '712401';
    $TransactionData['unique_id'] = 123;
    $TransactionData['pay_mode'] = 'production';
    $TransactionData['sub_merchant_id'] = '';

    $Response->PushData('TransactionData', $TransactionData, true);
}
catch (ApplicationDBException $e)
{
    $Response->SetError(1);
	$Response->SetErrorCode(UNKNOWN_ERROR);
	$Response->SetMessage(ProcessAppErrors(UNKNOWN_ERROR));

	echo json_encode($Response->GetResponseAsArray());
	exit;
}
catch (Exception $e)
{
	$Response->SetError(1);
	$Response->SetErrorCode(UNKNOWN_ERROR);
	$Response->SetMessage(ProcessAppErrors(UNKNOWN_ERROR));
	
	echo json_encode($Response->GetResponseAsArray());
	exit;
}

echo json_encode($Response->GetResponseAsArray());
exit;
?>