<?php
header("Content-Type:application/json");

require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/class.users.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/class.validation.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/class.authentication.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/class.date_processing.php');

require_once($_SERVER['DOCUMENT_ROOT'] . '/includes/global_defaults.inc.php');

require_once($_SERVER['DOCUMENT_ROOT'] . '/mobile_app_services/classes/class.json_response.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/mobile_app_services/includes/global_defaults.php');

require_once($_SERVER['DOCUMENT_ROOT'] . '/mobile_app_services/includes/process_errors.php');

//Other Required Classess
require_once($_SERVER['DOCUMENT_ROOT'] . '/mobile_app_services/classes/class.api_helpers.php');

require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/fee_management/class.fee_collection.php');

require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/school_administration/class.parent_details.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/mobile_app_services/classes/class.app.parent_details.php');

$Response = new JSONResponse();

$Clean = array();
$Filters = array();

$Clean['Token'] = '';

//	Other Variables
$Clean['StudentID'] = 0;

if (isset($_REQUEST['Token']))
{
	$Clean['Token'] = strip_tags(trim((string) $_REQUEST['Token']));
}

if (isset($_REQUEST['StudentID']))
{
	$Clean['StudentID'] = (int) $_REQUEST['StudentID'];
}

try
{
	$LoggedInParent = new AppParentDetail($Clean['Token']);
    
    if (!array_key_exists($Clean['StudentID'], $LoggedInParent->GetApplicableStudents())) 
	{
		$Response->SetError(1);
		$Response->SetErrorCode(UNKNOWN_ERROR);
		$Response->SetMessage(ProcessAppErrors(UNKNOWN_ERROR));

		echo json_encode($Response->GetResponseAsArray());
		exit;
	}
	
	$Filters = array();
	
	$Filters['AcademicYearID'] = 2; // Current Academic YearID
	$Filters['StudentID'] = $Clean['StudentID'];
	
	$FeeCollectionDetails = FeeCollection::SearchFeeCollectionDetails($TotalRecords, false, $Filters);
	
	$Data = array();
	$Counter = 0;
	foreach ($FeeCollectionDetails as $FeeCollectionID => $Details)
	{
	    if ($FeeCollectionID > 0)
	    {
	        $Data[$Counter]['Header'] = 'Receipt [ ' . date('d/m/Y', strtotime($Details['FeeDate'])) .' ]';
	       // $Data[$Counter]['FeeTransactionID'] = $Details['FeeTransactionID'];
	       
	        $Data[$Counter]['FeeTransactionID'] = $FeeCollectionID;
	        $Data[$Counter]['FeeReceiptPage'] = SITE_HTTP_PATH . '/admin/fee_management/fee_receipt.php?FeeTransactionID='. $Details['FeeTransactionID'] . '&is_temp=1';
	        
	        $Counter++;
	    }
	}

    $Response->PushData('FeeReceipts', $Data, true);
}
catch (ApplicationDBException $e)
{
    $Response->SetError(1);
	$Response->SetErrorCode(UNKNOWN_ERROR);
	$Response->SetMessage(ProcessAppErrors(UNKNOWN_ERROR));

	echo json_encode($Response->GetResponseAsArray());
	exit;
}
catch (Exception $e)
{
	$Response->SetError(1);
	$Response->SetErrorCode(UNKNOWN_ERROR);
	$Response->SetMessage(ProcessAppErrors(UNKNOWN_ERROR));
	
	echo json_encode($Response->GetResponseAsArray());
	exit;
}

echo json_encode($Response->GetResponseAsArray());
exit;
?>