<?php
// error_log(json_encode($_REQUEST));
header("Content-Type:application/json");

require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/class.users.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/class.validation.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/class.authentication.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/class.date_processing.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/includes/global_defaults.inc.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/mobile_app_services/classes/class.json_response.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/mobile_app_services/includes/global_defaults.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/mobile_app_services/includes/process_errors.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/school_administration/class.branch_staff.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/mobile_app_services/classes/class.app.branch_staff.php');
require_once ($_SERVER['DOCUMENT_ROOT'] . '/phpqrcode/qrlib.php');

$Response = new JSONResponse();

$token = md5(uniqid(rand(), true));
$teacherID = '';
$teacherName = '';
$dateTime = '';

if (isset($_REQUEST['Token']))
{
	$token = strip_tags(trim((string) $_REQUEST['Token']));
}

if (isset($_REQUEST['teacher_id']))
{
	$teacherID = (int) $_REQUEST['teacher_id'];
}

if (isset($_REQUEST['teacher_name']))
{
	$teacherName = strip_tags(trim((string) $_REQUEST['teacher_name']));
}

if (isset($_REQUEST['date_time']))
{
	$dateTime =  date('Y-m-d H:i:s', strtotime($_REQUEST['date_time']));
}

try
{
	$LoggedInBranchStaff = new AppBranchStaff($token);

    // Combine information to create data for QR code (you can customize the data format)
    $data = "Teacher ID: $teacherID\nName: $teacherName\nDate and Time: $dateTime";
    
    // Generate QR code image and save it to the server (you can also return it as a response)
    QRcode::png($data, 'qr_codes/'.$teacherID.'_'.time().'.png', QR_ECLEVEL_L, 5);


	$Response->PushData('ExamList', $Data);
}
catch (ApplicationDBException $e)
{
    $Response->SetError(1);
	$Response->SetErrorCode(UNKNOWN_ERROR);
	$Response->SetMessage(ProcessAppErrors(UNKNOWN_ERROR));

	echo json_encode($Response->GetResponseAsArray());
	exit;
}
catch (Exception $e)
{
	$Response->SetError(1);
	$Response->SetErrorCode(UNKNOWN_ERROR);
	$Response->SetMessage(ProcessAppErrors(UNKNOWN_ERROR));
	
	echo json_encode($Response->GetResponseAsArray());
	exit;
}

echo json_encode($Response->GetResponseAsArray());
exit;
?>
