<?php
// error_log(json_encode($_REQUEST));
header("Content-Type:application/json");

require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/class.users.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/class.validation.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/class.authentication.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/class.date_processing.php');

require_once($_SERVER['DOCUMENT_ROOT'] . '/includes/global_defaults.inc.php');

require_once($_SERVER['DOCUMENT_ROOT'] . '/mobile_app_services/classes/class.json_response.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/mobile_app_services/includes/global_defaults.php');

require_once($_SERVER['DOCUMENT_ROOT'] . '/mobile_app_services/includes/process_errors.php');

//Other Required Classess
require_once($_SERVER['DOCUMENT_ROOT'] . '/mobile_app_services/classes/class.api_helpers.php');

require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/school_administration/class.branch_staff.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/mobile_app_services/classes/class.app.branch_staff.php');

$Response = new JSONResponse();

$Clean = array();
$Filters = array();

$Clean['SchoolCode'] = '';
$Clean['Token'] = '';

//	Other Variables
$Clean['AppName'] = '';
$Clean['Duration'] = '';

if (isset($_REQUEST['SchoolCode']))
{
	$Clean['SchoolCode'] = strip_tags(trim((string) $_REQUEST['SchoolCode']));
}

if (isset($_REQUEST['Token']))
{
	$Clean['Token'] = strip_tags(trim((string) $_REQUEST['Token']));
}

if (isset($_REQUEST['AppName']))
{
	$Clean['AppName'] = strip_tags(trim((string) $_REQUEST['AppName']));
}

if (isset($_REQUEST['Duration']))
{
	$Clean['Duration'] = strip_tags(trim((string) $_REQUEST['Duration']));
}

try
{
	$LoggedInBranchStaff = new AppBranchStaff($Clean['Token']);

	if ($Clean['AppName'] == '')
	{
		$Response->SetError(1);
		$Response->SetErrorCode(UNKNOWN_ERROR);
		$Response->SetMessage(ProcessAppErrors(UNKNOWN_ERROR));	

		echo json_encode($Response->GetResponseAsArray());
		exit;
	}

    if ($LoggedInBranchStaff->IsBranchStaffPresent(date('Y-m-d')))
    {
        $CurrentTime = date('h:i:s');
        
        $StartTime = '';
        $EndTime = '';
        
        APIHelpers::SchoolTimming($StartTime, $EndTime);
        
        $CurrentTime = strtotime($CurrentTime);
        
        $StartTime = strtotime($StartTime);
        $EndTime = strtotime($EndTime);
        
        $EndTime = strtotime('15:00:00');
        
        if ($CurrentTime >= $StartTime and $CurrentTime <= $EndTime)
        {
            if (!APIHelpers::SaveAppLog($LoggedInBranchStaff->GetBranchStaffID(), $Clean['AppName'], $Clean['Duration'])) 
        	{
        		$Response->SetError(1);
        		$Response->SetErrorCode(UNKNOWN_ERROR);
        		$Response->SetMessage(ProcessAppErrors(UNKNOWN_ERROR));	
        
        		echo json_encode($Response->GetResponseAsArray());
        		exit;
        	}
        }
    }
	
	$Response->SetMessage(ProcessAppMessages(SAVED_SUCCESSFULLY));
}
catch (ApplicationDBException $e)
{
    $Response->SetError(1);
	$Response->SetErrorCode(UNKNOWN_ERROR);
	$Response->SetMessage(ProcessAppErrors(UNKNOWN_ERROR));

	echo json_encode($Response->GetResponseAsArray());
	exit;
}
catch (Exception $e)
{
	$Response->SetError(1);
	$Response->SetErrorCode(UNKNOWN_ERROR);
	$Response->SetMessage(ProcessAppErrors(UNKNOWN_ERROR));
	
	echo json_encode($Response->GetResponseAsArray());
	exit;
}

echo json_encode($Response->GetResponseAsArray());
exit;
?>