<?php
//header('Content-Type: application/json');

require_once('../classes/class.users.php');
require_once('../classes/class.authentication.php');

try
{
	$AuthObject = new ApplicationAuthentication;
	$LoggedUser = new User(0, $AuthObject->CheckValidUser());
}

// THIS CATCH BLOCK BUBBLES THE EXCEPTION TO THE BUILT IN 'Exception' CLASS IF THERE ARE ANY UNCAUGHT ERRORS //
catch (ApplicationAuthException $e)
{
	echo 'error|*****|Unknown error, please try again.';
	exit;
}
catch (Exception $e)
{
	echo 'error|*****|Unknown error, please try again.';
	exit;
}

require_once("../classes/class.date_processing.php");
require_once("../classes/school_administration/class.class_helpers.php");

$StudentID = 0;
$ClubActivities = '';

if (isset($_POST['StudentID']))
{
	$StudentID = (int) $_POST['StudentID'];
}

if (isset($_POST['ClubActivities']))
{
	$ClubActivities = (string) $_POST['ClubActivities'];
}

if ($StudentID <= 0 || $ClubActivities == '')
{
	echo 'error|*****|Please enter club activities.';
	exit;
}

if (!ClassHelpers::UpdateStudentClubActivities($StudentID, $ClubActivities))
{
	echo 'error|*****|Error in saving club activities.';
	exit;
}

echo 'success|*****|';

exit;
?>